package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import austenx.general.lexi.tokens.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
public final class DesignExpressionReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 42;
	private final SkeletonPackrat basePackrat_;
	public DesignExpressionReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = 0;
		result.mark();
		width = decodePrimitiveForDesignExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 0, 42);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeVariableForDesignExpression(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 1, 42);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		return null;
	}
	public final int decodePrimitiveForDesignExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_5(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub_1(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_4(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub_2(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_3(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isCHAR()) {
			return -1;
		}
		result.addSubToken(0, token);
		newOffset++;
		return newOffset;
	}
	public final int itemSub_3(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isSTRING()) {
			return -1;
		}
		result.addSubToken(1, token);
		newOffset++;
		return newOffset;
	}
	public final int itemSub_4(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isINTEGER()) {
			return -1;
		}
		result.addSubToken(2, token);
		newOffset++;
		return newOffset;
	}
	public final int itemSub_5(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isBOOLEAN_VALUE()) {
			return -1;
		}
		result.addSubToken(3, token);
		newOffset++;
		return newOffset;
	}
	public final int decodeVariableForDesignExpression(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		return newOffset;
	}
}
