package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
import austenx.general.lexi.tokens.*;
public final class JavaCallChainReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 27;
	private final SkeletonPackrat basePackrat_;
	public JavaCallChainReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = decodeJavaCallChain(result, c, 0);
		if(width > 0) {
			result.setDetails(width, 0, 27);
			return oldElement.getImprovedByOrNull(result);
		}
		return null;
	}
	public final int decodeJavaCallChain(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		result.mark();
		int checkOffset_1 = dividedPrimarySub(result, c, newOffset);
		if(checkOffset_1 < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset_1;
			result.bumpLastMark();
			while(checkOffset_1 > 0) {
				checkOffset_1 = dividedSecondarySub(result, c, newOffset);
				if(checkOffset_1 >= 0) {
					checkOffset_1 = dividedPrimarySub(result, c, checkOffset_1);
				}
				if(checkOffset_1 >= 0) {
					newOffset = checkOffset_1;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		result.mark();
		int checkOffset_2 = maybeSub_1(result, c, newOffset);
		if(checkOffset_2 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_2;
			result.removeLastMark();
		}
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isTHIS_KEYWORD()) {
			return -1;
		}
		result.addSubToken(0, token);
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isFULL_STOP_SYMBOL()) {
			return -1;
		}
		result.addSubToken(-1, token_1);
		newOffset++;
		return newOffset;
	}
	public final int dividedPrimarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 65).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int dividedSecondarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isFULL_STOP_SYMBOL()) {
			return -1;
		}
		result.addSubToken(-1, token);
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isFULL_STOP_SYMBOL()) {
			return -1;
		}
		result.addSubToken(-1, token_1);
		newOffset++;
		return newOffset;
	}
	public final int maybeSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isLEFT_SQUARE()) {
			return -1;
		}
		result.addSubToken(-1, token);
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 24).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		SkeletonToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isRIGHT_SQUARE()) {
			return -1;
		}
		result.addSubToken(-1, token_1);
		newOffset++;
		return newOffset;
	}
}
