package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
import austenx.general.lexi.tokens.*;
public final class JavaClassReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 16;
	private final SkeletonPackrat basePackrat_;
	public JavaClassReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = decodeJavaClass(result, c, 0);
		if(width > 0) {
			result.setDetails(width, 0, 16);
			return oldElement.getImprovedByOrNull(result);
		}
		return null;
	}
	public final int decodeJavaClass(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_1(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		int checkOffset_2 = newOffset;
		result.mark();
		while(checkOffset_2 >= 0) {
			checkOffset_2 = zeroOrMoreSub(result, c, newOffset);
			if(checkOffset_2 > newOffset) {
				newOffset = checkOffset_2;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isCLASS_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(4, token);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(5, token_1);
		result.mark();
		int checkOffset_3 = maybeSub(result, c, newOffset);
		if(checkOffset_3 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_3;
			result.removeLastMark();
		}
		result.mark();
		int checkOffset_4 = maybeSub_1(result, c, newOffset);
		if(checkOffset_4 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_4;
			result.removeLastMark();
		}
		result.mark();
		int checkOffset_5 = maybeSub_2(result, c, newOffset);
		if(checkOffset_5 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_5;
			result.removeLastMark();
		}
		result.mark();
		int checkOffset_6 = maybeSub_3(result, c, newOffset);
		if(checkOffset_6 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_6;
			result.removeLastMark();
		}
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isLEFT_CURLY()) {
			return -1;
		}
		newOffset++;
		int checkOffset_7 = newOffset;
		result.mark();
		while(checkOffset_7 >= 0) {
			checkOffset_7 = zeroOrMoreSub_1(result, c, newOffset);
			if(checkOffset_7 > newOffset) {
				newOffset = checkOffset_7;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		BasicTokensToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isRIGHT_CURLY()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int itemSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isPUBLIC_KEYWORD()) {
			return -1;
		}
		result.addSubToken(0, token);
		newOffset++;
		return newOffset;
	}
	public final int itemSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isPRIVATE_KEYWORD()) {
			return -1;
		}
		result.addSubToken(1, token);
		newOffset++;
		return newOffset;
	}
	public final int zeroOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub_2(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_3(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isFINAL_KEYWORD()) {
			return -1;
		}
		result.addSubToken(2, token);
		newOffset++;
		return newOffset;
	}
	public final int itemSub_3(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isSTATIC_KEYWORD()) {
			return -1;
		}
		result.addSubToken(3, token);
		newOffset++;
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 31).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int maybeSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isEXTENDS_KEYWORD()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 49).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int maybeSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isIMPLEMENTS_KEYWORD()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 49).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(2, rule);
		return newOffset;
	}
	public final int maybeSub_3(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 51).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(3, rule);
		return newOffset;
	}
	public final int zeroOrMoreSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 19).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(4, rule);
		return newOffset;
	}
}
