package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import austenx.general.lexi.tokens.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
public final class LabelingSubsReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 8;
	private final SkeletonPackrat basePackrat_;
	public LabelingSubsReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = 0;
		result.mark();
		width = decodeVariableSubForLabelingSubs(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 0, 8);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeMethodSubForLabelingSubs(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 1, 8);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		return null;
	}
	public final int decodeVariableSubForLabelingSubs(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		result.mark();
		int checkOffset_1 = maybeSub_1(result, c, newOffset);
		if(checkOffset_1 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_1;
			result.removeLastMark();
		}
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(1, token);
		int checkOffset_2 = newOffset;
		result.mark();
		while(checkOffset_2 >= 0) {
			checkOffset_2 = zeroOrMoreSub(result, c, newOffset);
			if(checkOffset_2 > newOffset) {
				newOffset = checkOffset_2;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(3, token_1);
		result.mark();
		int checkOffset_3 = maybeSub_2(result, c, newOffset);
		if(checkOffset_3 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_3;
			result.removeLastMark();
		}
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isPUBLIC_KEYWORD()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int maybeSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isSTATIC_KEYWORD()) {
			return -1;
		}
		result.addSubToken(0, token);
		newOffset++;
		return newOffset;
	}
	public final int zeroOrMoreSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isLEFT_SQUARE()) {
			return -1;
		}
		newOffset++;
		SkeletonToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isRIGHT_SQUARE()) {
			return -1;
		}
		result.addSubToken(2, token_1);
		newOffset++;
		return newOffset;
	}
	public final int maybeSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isASSIGNMENT()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		result.addSubToken(4, token_1);
		newOffset++;
		return newOffset;
	}
	public final int decodeMethodSubForLabelingSubs(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.mark();
		int checkOffset = maybeSub_3(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		result.mark();
		int checkOffset_1 = maybeSub_4(result, c, newOffset);
		if(checkOffset_1 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_1;
			result.removeLastMark();
		}
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(1, token);
		int checkOffset_2 = newOffset;
		result.mark();
		while(checkOffset_2 >= 0) {
			checkOffset_2 = zeroOrMoreSub_1(result, c, newOffset);
			if(checkOffset_2 > newOffset) {
				newOffset = checkOffset_2;
				result.bumpLastMark();
			} else {
				result.undoToMark();
			}
		}
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(3, token_1);
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isLEFT_ROUND()) {
			return -1;
		}
		newOffset++;
		result.mark();
		int checkOffset_3 = maybeSub_5(result, c, newOffset);
		if(checkOffset_3 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_3;
			result.removeLastMark();
		}
		BasicTokensToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isRIGHT_ROUND()) {
			return -1;
		}
		newOffset++;
		result.mark();
		int checkOffset_4 = maybeSub_6(result, c, newOffset);
		if(checkOffset_4 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_4;
			result.removeLastMark();
		}
		BasicTokensToken token_4 = c.getColumnToken(newOffset);
		if(!token_4.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int maybeSub_3(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isPUBLIC_KEYWORD()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int maybeSub_4(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isSTATIC_KEYWORD()) {
			return -1;
		}
		result.addSubToken(0, token);
		newOffset++;
		return newOffset;
	}
	public final int zeroOrMoreSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isLEFT_SQUARE()) {
			return -1;
		}
		newOffset++;
		SkeletonToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isRIGHT_SQUARE()) {
			return -1;
		}
		result.addSubToken(2, token_1);
		newOffset++;
		return newOffset;
	}
	public final int maybeSub_5(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		result.mark();
		int checkOffset = dividedPrimarySub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset;
			result.bumpLastMark();
			while(checkOffset > 0) {
				checkOffset = dividedSecondarySub(result, c, newOffset);
				if(checkOffset >= 0) {
					checkOffset = dividedPrimarySub(result, c, checkOffset);
				}
				if(checkOffset >= 0) {
					newOffset = checkOffset;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		return newOffset;
	}
	public final int dividedPrimarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 40).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int dividedSecondarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isCOMMA_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int maybeSub_6(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isASSIGNMENT()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		result.addSubToken(4, token_1);
		newOffset++;
		return newOffset;
	}
}
