package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import austenx.general.lexi.tokens.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
public final class TargetParameterReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 36;
	private final SkeletonPackrat basePackrat_;
	public TargetParameterReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = 0;
		result.mark();
		width = decodeSimpleForTargetParameter(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 0, 36);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeLinkForTargetParameter(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 1, 36);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeMarkForTargetParameter(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 2, 36);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		return null;
	}
	public final int decodeSimpleForTargetParameter(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 25).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 31).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int decodeLinkForTargetParameter(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isLINK_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		result.mark();
		int checkOffset = dividedPrimarySub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset;
			result.bumpLastMark();
			while(checkOffset > 0) {
				checkOffset = dividedSecondarySub(result, c, newOffset);
				if(checkOffset >= 0) {
					checkOffset = dividedPrimarySub(result, c, checkOffset);
				}
				if(checkOffset >= 0) {
					newOffset = checkOffset;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_2 = itemSub_3(result, c, newOffset);
			if(checkOffset_2 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_2;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int dividedPrimarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 34).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int dividedSecondarySub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isCOMMA_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int itemSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset = itemSub_1(result, c, newOffset);
			if(checkOffset < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_1 = itemSub_2(result, c, newOffset);
			if(checkOffset_1 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_1;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		return newOffset;
	}
	public final int itemSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isFULL_STOP_SYMBOL()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isFULL_STOP_SYMBOL()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isFULL_STOP_SYMBOL()) {
			return -1;
		}
		newOffset++;
		result.mark();
		int checkOffset = dividedPrimarySub_1(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset;
			result.bumpLastMark();
			while(checkOffset > 0) {
				checkOffset = dividedSecondarySub_1(result, c, newOffset);
				if(checkOffset >= 0) {
					checkOffset = dividedPrimarySub_1(result, c, checkOffset);
				}
				if(checkOffset >= 0) {
					newOffset = checkOffset;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		return newOffset;
	}
	public final int dividedPrimarySub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 36).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int dividedSecondarySub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isCOMMA_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int itemSub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 36).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int itemSub_3(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isLEFT_CURLY()) {
			return -1;
		}
		newOffset++;
		result.mark();
		int checkOffset = dividedPrimarySub_2(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
			return -1;
		} else {
			newOffset = checkOffset;
			result.bumpLastMark();
			while(checkOffset > 0) {
				checkOffset = dividedSecondarySub_2(result, c, newOffset);
				if(checkOffset >= 0) {
					checkOffset = dividedPrimarySub_2(result, c, checkOffset);
				}
				if(checkOffset >= 0) {
					newOffset = checkOffset;
					result.bumpLastMark();
				} else {
					result.undoToMark();
				}
			}
		}
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isRIGHT_CURLY()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int dividedPrimarySub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 36).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(1, rule);
		return newOffset;
	}
	public final int dividedSecondarySub_2(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isCOMMA_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int decodeMarkForTargetParameter(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isMARK_KEYWORD()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token_1);
		return newOffset;
	}
}
