package org.ffd2.skeletonx.austenx.peg.base;
import org.ffd2.skeletonx.austenx.packrat.impl.*;
public final class DeferredGlobalElementImpl implements DeferredGlobalElement {
	private final org.ffd2.austenx.runtime.ResolvedPackratElement myElement_;
	public DeferredGlobalElementImpl(org.ffd2.austenx.runtime.ResolvedPackratElement myElement) {
		myElement_ = myElement;
	}
	public final void buildGlobalElement(GlobalElementPeer.Indirect target) {
		final org.ffd2.austenx.runtime.ResolvedPackratElement element = myElement_;
		int type = element.getType();
		if(type == 0) {
			org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
			GlobalElementPeer.LinkPatternPeer child = target.createLink(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
			if(child != null) {
				element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_2(child));
				child.end();
			}
		}
		if(type == 1) {
			GlobalElementPeer.MethodPatternPeer child_1 = target.createMethod();
			if(child_1 != null) {
				element.updateConstruction(new AllDecodersSkeleton.MethodDecoder_2(child_1));
				child_1.end();
			}
		}
	}
}
