package org.ffd2.skeletonx.austenx.peg.base;
import org.ffd2.skeletonx.austenx.packrat.impl.*;
public final class DeferredJavaImplementationElementImpl implements DeferredJavaImplementationElement {
	private final org.ffd2.austenx.runtime.ResolvedPackratElement myElement_;
	public DeferredJavaImplementationElementImpl(org.ffd2.austenx.runtime.ResolvedPackratElement myElement) {
		myElement_ = myElement;
	}
	public final void buildJavaImplementationElement(JavaImplementationElementPeer.Indirect target) {
		final org.ffd2.austenx.runtime.ResolvedPackratElement element = myElement_;
		int type = element.getType();
		if(type == 0) {
			JavaImplementationElementPeer.ClassPatternPeer child = target.createClass();
			if(child != null) {
				element.updateConstruction(new AllDecodersSkeleton.ClassDecoder(child));
				child.end();
			}
		}
		if(type == 1) {
			JavaImplementationElementPeer.InterfacePatternPeer child_1 = target.createInterface();
			if(child_1 != null) {
				element.updateConstruction(new AllDecodersSkeleton.InterfaceDecoder(child_1));
				child_1.end();
			}
		}
		if(type == 2) {
			JavaImplementationElementPeer.LinkPatternPeer child_2 = target.createLink();
			if(child_2 != null) {
				element.updateConstruction(new AllDecodersSkeleton.LinkDecoder(child_2));
				child_2.end();
			}
		}
		if(type == 3) {
			org.ffd2.austenx.runtime.BaseToken fileNameToken = element.getBaseArgumentToken(0);
			target.createInclude(fileNameToken.getStringValue(), fileNameToken.getLineNumber(), fileNameToken.getCharacterNumber());
		}
		if(type == 4) {
			JavaImplementationElementPeer.IfPatternPeer child_3 = target.createIf();
			if(child_3 != null) {
				element.updateConstruction(new AllDecodersSkeleton.IfDecoder(child_3));
				child_3.end();
			}
		}
		if(type == 5) {
			org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
			JavaImplementationElementPeer.PackageSetPatternPeer child_4 = target.createPackageSet(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
			if(child_4 != null) {
				element.updateConstruction(new AllDecodersSkeleton.PackageSetDecoder(child_4));
				child_4.end();
			}
		}
		if(type == 6) {
			JavaImplementationElementPeer.MacroDefPatternPeer child_5 = target.createMacroDef();
			if(child_5 != null) {
				element.updateConstruction(new AllDecodersSkeleton.MacroDefDecoder(child_5));
				child_5.end();
			}
		}
		if(type == 7) {
			JavaImplementationElementPeer.MacroCallPatternPeer child_6 = target.createMacroCall();
			if(child_6 != null) {
				element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder(child_6));
				child_6.end();
			}
		}
		if(type == 8) {
			JavaImplementationElementPeer.GlobalClassPatternPeer child_7 = target.createGlobalClass();
			if(child_7 != null) {
				element.updateConstruction(new AllDecodersSkeleton.GlobalClassDecoder(child_7));
				child_7.end();
			}
		}
		if(type == 9) {
			JavaImplementationElementPeer.FindPatternPeer child_8 = target.createFind();
			if(child_8 != null) {
				element.updateConstruction(new AllDecodersSkeleton.FindDecoder(child_8));
				child_8.end();
			}
		}
	}
}
