package org.ffd2.skeletonx.austenx.peg.base;
import org.ffd2.skeletonx.austenx.packrat.impl.*;
public final class DeferredTargetParameterImpl implements DeferredTargetParameter {
	private final org.ffd2.austenx.runtime.ResolvedPackratElement myElement_;
	public DeferredTargetParameterImpl(org.ffd2.austenx.runtime.ResolvedPackratElement myElement) {
		myElement_ = myElement;
	}
	public final void buildTargetParameter(TargetParameterPeer.Indirect target) {
		final org.ffd2.austenx.runtime.ResolvedPackratElement element = myElement_;
		int type = element.getType();
		if(type == 0) {
			org.ffd2.austenx.runtime.BaseToken nameToken = element.getBaseArgumentToken(0);
			TargetParameterPeer.SimplePatternPeer child = target.createSimple(nameToken.getStringValue(), nameToken.getLineNumber(), nameToken.getCharacterNumber());
			if(child != null) {
				element.updateConstruction(new AllDecodersSkeleton.SimpleDecoder(child));
				child.end();
			}
		}
		if(type == 1) {
			org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
			TargetParameterPeer.LinkPatternPeer child_1 = target.createLink(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
			if(child_1 != null) {
				element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_5(child_1));
				child_1.end();
			}
		}
		if(type == 2) {
			org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
			target.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
		}
	}
}
