package org.ffd2.skeletonx.austenx.peg.base;
public final class SpecificsBlockElementPeer {
	public static interface Indirect {
		public SpecificsBlockElementPeer.MethodPatternPeer createMethod(java.lang.String name, int nameLine, int nameCharacter) ;
		public SpecificsBlockElementPeer.SubPatternPeer createSub() ;
		public SpecificsBlockElementPeer.ClassReferencePatternPeer createClassReference(java.lang.String className, int classNameLine, int classNameCharacter) ;
	}
	public static interface MethodPatternPeer {
		public void end() ;
		public void addIsStatic() ;
		public TargetTypeReferencePatternPeer addTargetTypeReferenceForReturnType(java.lang.String typeName, int typeNameLine, int typeNameCharacter) ;
	}
	public static interface SubPatternPeer {
		public void end() ;
		public JavaImplementationSpecificsBlockPatternPeer addJavaImplementationSpecificsBlockForSubBlock(java.lang.String blockName, int blockNameLine, int blockNameCharacter) ;
	}
	public static interface ClassReferencePatternPeer {
		public void end() ;
		public SpecificsBlockElementPeer.Indirect getSpecificsBlockElementForElements() ;
	}
}
