package org.ffd2.skeletonx.compile.design;

import org.ffd2.skeletonx.compile.impl.ChainDefinitionBlock;
import org.ffd2.skeletonx.compile.impl.MappingDefinitionBlock;
import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.ParameterSettingsFormHolder;
//import skeletonx.skeleton.BaseBuilder.ParameterSettingsTemplate.ParameterTemplate.RecordTemplate.IsFixedTemplate;
import org.ffd2.skeletonx.skeleton.BaseTrackers;

public interface FixedValueAccess {
	public void buildParameters(ParameterSource source);
	public void requestRecordFromVariableFinal(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock fixedSkeleton, BaseTrackers.DesignVariablePath variablePath);

	public static interface ParameterSource {
		//public void addIntValue(String parameterName)
		public void addDesignRecord(String variableName, DesignType recordType,ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock  fixedSkeleton);
		public void addIntValue(String variableName, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock  fixedSkeleton);
		public void addIntArrayValue(String variableName, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock  fixedSkeleton);
		public void addStringValue(String variableName, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock  fixedSkeleton);
		public void addDoubleValue(String variableName, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock  fixedSkeleton);
		public void addBooleanValue(String variableName, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock  fixedSkeleton);
		public void addChain(String variableName, ChainDefinitionBlock chainAccess, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock  fixedSkeleton);
		public void addMapping(String variableName, MappingDefinitionBlock mappingAccess, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock  fixedSkeleton);

	}
}
