package org.ffd2.skeletonx.compile.impl;

import java.io.IOException;

import org.ffd2.skeletonx.compile.java.JavaExternalBlock;
import org.ffd2.solar.compile.GlobalEnvironment;
import org.ffd2.solar.exceptions.ParsingException;
import org.ffd2.solar.language.AccessStoreX;

public interface FileEnvironment {
  public <Type> AccessStoreX<Type> createEntityStore(String typeName);
  
  public GlobalEnvironment getImplementationGlobalEnvironment();
  public GlobalEnvironment getDefintionGlobalEnvironment();
  public DesignBlock getDesign(String name) throws ParsingException;
  public JavaExternalBlock getJavaExternal(String name) throws ParsingException;
  public FileEnvironment getExternalEnvironment(String namespace) throws ParsingException;
  public String readFile(String fileName) throws IOException ;
  
}
