package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.compile.java.layer.SLayer;
import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.GeneralTargetVariableDataBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock;

public interface ElementSetItems {
	public JavaImplementationFormBlock.BlockDataBlock getBase(); //Shouldn't need this
  public GeneralTargetVariableDataBlock addGeneralTargetVariableCodeVariable(String variableName);
  public JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.ParameterVariableStoreDataBlock addParameterTargetVariableStore(String variableName);
	public MacroCallInstance createMacroCallFinal(
			String variableName,
			MacroConstruction macro,
			MacroCallRequirementsAccess requirementsAccess,
			SLayer parentRecord
		);
	// May be wrong ItemDataBlock..
  public JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock addItemSkeleton();
	public ElementSetItems allocateNew(String name);
}
