/**
 * 
 */
package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.compile.impl.ChainDefinitionBlock;
import org.ffd2.skeletonx.compile.java.layer.FoundationNode;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.solar.exceptions.ItemNotFoundException;

//Doesn't appear to be used any more
public interface RecordImplementationType {
  //public void checkIsIdentified(SimpleVector<SpecificCommonErrorOutput> requestErrors);
  public String getStringDescription();
  
  public ChainDefinitionBlock getChainDefinition(String name) throws ItemNotFoundException;
	
//  public void addPathVariablesToRecordData(BaseTrackers.JavaVariablePath targetChain, RecordAccess topLevelLink); 
  //public void addPathVariablesToRecordDataSimple(BaseTrackers.JavaVariablePath targetChain); 
  /**
   * Search back up the tree for the requested variable.
   * @param outputClass
   * @param variableName
   * @return the variable access if found
   * @throws ItemNotFoundException
   */
//  public TargetVariable accessVariableBackwards(TargetType outputClass, String variableName, BaseTrackers.JavaVariablePath chainToVariable) throws ItemNotFoundException;
  public VariableAccess getTargetVariableAccessQuietBackwards(boolean allowLocalVariables,TargetType outputClass,RecordVariableTrace variableTrace, String variableName, BaseTrackers.JavaVariablePath chainToVariable);

  public MacroConstruction getMacroConstructionBasicBackwards(String name) throws ItemNotFoundException;
  	
  public FoundationNode getRootRecordQuiet(String childName);
  
  public MethodAccess getTargetMethodAccessQuietBackwards(TargetType outputClass,RecordVariableTrace variableTrace,  String name, BaseTrackers.JavaVariablePath chainToVariable);

  public TargetVariable getTargetLocalVariableQuietBackwards(ScopeContainer relatedScope, RecordVariableTrace variableTrace, String variableName, JavaVariablePath chainToVariable);
  public boolean isLocalVariableQuietBackwards(ScopeContainer relatedScope, RecordVariableTrace variableTrace, String variableName);
//  public TargetMethod accessMethodBackwards(TargetType outputClass, String methodName, BaseTrackers.JavaVariablePath chainToVariable) throws ItemNotFoundException;
  
//  public RecordAccess getLinkedToParentChildAccessBackwardsQuiet(
//                                                                 String childName, 
//                                                                 ImplementationRecord surroundingRecord, 
//                                                                 BaseTrackers.JavaVariablePath basePathToLinkedFromStore
//                                                                );
//  
  
  /**
   * Yeah, it's a bit odd having the name there - will have to look into changing.
   * @param outputClass
   * @param typeName
   * @param chainToVariable
   * @throws ItemNotFoundException
   */
  public void accessInternalTypeBackwards(TargetType outputClass,BaseTrackers.JavaVariablePath chainToVariable);
  
  public boolean queryAccessTypeInternalBackwards(TargetType outputClass, BaseTrackers.JavaVariablePath chainToVariable);
  
  public TargetType getTargetTypeQuietBackwards(RecordVariableTrace variableTrace,  String typeName, BaseTrackers.JavaVariablePath chainToVariable);
    
  public IRecordVariable getResolvedVariableQuietBackwards(RecordVariableTrace variableTrace, String variableName, BaseTrackers.JavaVariablePath variablePath);

//  public void buildPathToRecordBackwardsQuiet(RecordAccess record,BaseTrackers.JavaVariablePath chainToVariable);

}