package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.compile.java.layer.FoundationNode;
import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock;
import org.ffd2.skeletonx.skeleton.JavaParameterSettingsFormHolder.JavaParameterSettingsFormBlock;

import org.ffd2.solar.exceptions.ParsingException;

public interface SLayerRecordReference {
	public void doVariableQueryMatchAsQueryParameter(
			JavaImplementationFormBlock.BlockDataBlock.SearchRecordDataBlock targetSkeleton, 
			 BaseTrackers.JavaVariablePath  variablePathToTestValueFromSearchLayer,
			IRecordVariable queryMatchValue, BaseTrackers.JavaVariablePath variablePathToQueryMatch) throws ParsingException;
	/*
	 * create a query match, whereby this record is the parameter, and the value is this.
	 */
	public void doRecordThisMatchAsQueryParameter(
			JavaImplementationFormBlock.BlockDataBlock.SearchRecordDataBlock targetSkeleton, 
			BaseTrackers.JavaVariablePath  variablePathToParameterFromSearchLayer,
			FoundationNode recordType,
			BaseTrackers.JavaVariablePath  variablePathToRecordQueryValueFromSearchLayer
		) throws ParsingException;
	
	public void doVariableQueryMatchAsQueryValue( 
			BaseTrackers.JavaVariablePath  variablePathToTestValueFromSearchLayer, 
			 JavaParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock testParameter,
			JavaImplementationFormBlock.BlockDataBlock.SearchRecordDataBlock targetSkeleton, 
			BaseTrackers.JavaVariablePath variablePathToQueryMatch);

	public void addAsPathElement(BaseTrackers.JavaVariablePath path) throws ParsingException;

}
