package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.skeleton.BaseBuilder;
import org.ffd2.skeletonx.skeleton.BasicCallChainFormHolder.BasicCallChainFormBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.solar.exceptions.ParsingException;

public interface TargetVariable {
//  public TargetType getHostingType();
//  /**
//   * Does not have to be valid until Intermediate pass
//   * @param toTypeDefChainStorage storage for the links from the hosting area of the target variable to the declaration of its TargetType
//   * @return the target type, or null if type not available.
//   */
//  public TargetType getTargetType(BaseTrackers.JavaVariablePath toTypeDefChainStorage);
  
  public void createCallExpressionFinal(BasicCallChainFormBlock target, BaseTrackers.JavaVariablePath basePathDisposable);
  
  
  public TargetTypeReference getTargetTypeReferenceQuietFinal();
//  public TargetTypeReference getTargetTypeReferenceFinal() throws ParsingException;

  public void createMacroCallParameter(MacroCallDataBlock macroCallBlock, BaseTrackers.JavaVariablePath pathToVariable) throws ParsingException;
  
}
