package org.ffd2.skeletonx.compile.java.layer;

import org.ffd2.skeletonx.compile.impl.FileEnvironment;
import org.ffd2.skeletonx.compile.java.IRecordVariable;
import org.ffd2.skeletonx.compile.java.LinkupTracker;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.solar.exceptions.ParsingException;

public interface NonFoundationChildSLayerMaker {
	public NodeLayerChild createNewNodeLayerChild(String name, ImplementationBlockSkeletonManager blockSkeleton, LinkupTracker	relatedTracker, SLayer parentLayer, LayerType parentLayerType, FileEnvironment fileEnvironment, int lineNumber) throws ParsingException;
	public VariableChild 
		createNewVariableLayerChildNonLocal(
				String name, SLayer parentLayer, LayerType parentLayerType, FileEnvironment fileEnvironment, int lineNumber) throws ParsingException;
	public VariableChild 
		createNewVariableLayerChild(
				String name, IRecordVariable resolvedVariable, BaseTrackers.JavaVariablePath pathToVariableDefinition,
				SLayer parentLayer, LayerType parentLayerType, FileEnvironment fileEnvironment, int lineNumber
			) throws ParsingException;	

}
