package org.ffd2.skeletonx.skeleton;
public final class ChainBlockFormHolder {
	public static final class ChainBlockFormBlock {
		private final ChainBlockFormHolder.ChainBlockFormBlock previous_;
		public BaseBuilder parent_;
		public ChainBlockFormHolder.ChainBlockFormBlock.LinkTypeDataBlock linkTypeEnd_ = null;
		private final java.lang.String chainNameParameter_;
		private final IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock relatedTrackerParameter_;
		private final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock targetPeerParameter_;
		private org.ffd2.bones.base.BClass chainBlockClassBonesClass_;
		private org.ffd2.bones.base.BClass linkBonesClass_;
		private org.ffd2.bones.base.InstanceVariable linkStore_Bones_;
		private org.ffd2.bones.base.InstanceVariable index_Bones_;
		private final org.ffd2.bones.base.LocalVariableDeclaration peerBones_;
		private final org.ffd2.bones.base.LocalVariableDeclaration linkCountBones_;
		private final org.ffd2.bones.base.LocalVariableDeclaration iBones_;
		private final org.ffd2.bones.base.LocalVariableDeclaration lBones_;
		private final org.ffd2.bones.base.ParameterVariable trackerBones_;
		private final org.ffd2.bones.base.ParameterVariable otherBones_;
		private final org.ffd2.bones.base.ParameterVariable peerBaseBones_;
		private final org.ffd2.bones.base.ParameterVariable indexBones_;
		private final org.ffd2.bones.base.ParameterVariable linkIndexBones_;
		private final org.ffd2.bones.base.ParameterVariable peerBones_1_;
		private final org.ffd2.bones.base.BCodeBlock constructorCode_;
		private final org.ffd2.bones.base.BCodeBlock addFromCode_;
		private final org.ffd2.bones.base.BCodeBlock clearAllCode_;
		private final org.ffd2.bones.base.BCodeBlock getSizeCode_;
		private final org.ffd2.bones.base.BCodeBlock updatePeerCode_;
		private final org.ffd2.bones.base.BCodeBlock getChainIndexCode_;
		private final org.ffd2.bones.base.BCodeBlock markCode_;
		private final org.ffd2.bones.base.BCodeBlock unmarkCode_;
		private org.ffd2.bones.base.BMethod addFromMethod_;
		private org.ffd2.bones.base.BMethod clearAllMethod_;
		private org.ffd2.bones.base.BMethod getSizeMethod_;
		private org.ffd2.bones.base.BMethod updatePeerMethod_;
		private org.ffd2.bones.base.BMethod getChainIndexMethod_;
		private org.ffd2.bones.base.BMethod markMethod_;
		private org.ffd2.bones.base.BMethod unmarkMethod_;
		private org.ffd2.bones.base.BMethod updateChainMethod_;
		private final org.ffd2.bones.base.BConstructor bonesConstructor_;
		public ChainBlockFormBlock(BaseBuilder parent, java.lang.String chainName, IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock relatedTracker, TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock targetPeer, ChainBlockFormHolder.ChainBlockFormBlock previous) {
			previous_ = previous;
			chainNameParameter_ = chainName;
			relatedTrackerParameter_ = relatedTracker;
			targetPeerParameter_ = targetPeer;
			parent_ = parent;
			chainBlockClassBonesClass_ = new org.ffd2.bones.base.BClass(true);
			linkBonesClass_ = new org.ffd2.bones.base.BClass(false);
			linkStore_Bones_ = new org.ffd2.bones.base.InstanceVariable();
			index_Bones_ = new org.ffd2.bones.base.InstanceVariable();
			peerBones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
			linkCountBones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
			iBones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
			lBones_ = new org.ffd2.bones.base.LocalVariableDeclaration();
			trackerBones_ = new org.ffd2.bones.base.ParameterVariable();
			otherBones_ = new org.ffd2.bones.base.ParameterVariable();
			peerBaseBones_ = new org.ffd2.bones.base.ParameterVariable();
			indexBones_ = new org.ffd2.bones.base.ParameterVariable();
			linkIndexBones_ = new org.ffd2.bones.base.ParameterVariable();
			peerBones_1_ = new org.ffd2.bones.base.ParameterVariable();
			constructorCode_ = new org.ffd2.bones.base.BCodeBlock();
			addFromCode_ = new org.ffd2.bones.base.BCodeBlock();
			clearAllCode_ = new org.ffd2.bones.base.BCodeBlock();
			getSizeCode_ = new org.ffd2.bones.base.BCodeBlock();
			updatePeerCode_ = new org.ffd2.bones.base.BCodeBlock();
			getChainIndexCode_ = new org.ffd2.bones.base.BCodeBlock();
			markCode_ = new org.ffd2.bones.base.BCodeBlock();
			unmarkCode_ = new org.ffd2.bones.base.BCodeBlock();
			addFromMethod_ = new org.ffd2.bones.base.BMethod();
			addFromMethod_.setCodeBlock(getAddFromCode());
			clearAllMethod_ = new org.ffd2.bones.base.BMethod();
			clearAllMethod_.setCodeBlock(getClearAllCode());
			getSizeMethod_ = new org.ffd2.bones.base.BMethod();
			getSizeMethod_.setCodeBlock(getGetSizeCode());
			updatePeerMethod_ = new org.ffd2.bones.base.BMethod();
			updatePeerMethod_.setCodeBlock(getUpdatePeerCode());
			getChainIndexMethod_ = new org.ffd2.bones.base.BMethod();
			getChainIndexMethod_.setCodeBlock(getGetChainIndexCode());
			markMethod_ = new org.ffd2.bones.base.BMethod();
			markMethod_.setCodeBlock(getMarkCode());
			unmarkMethod_ = new org.ffd2.bones.base.BMethod();
			unmarkMethod_.setCodeBlock(getUnmarkCode());
			updateChainMethod_ = new org.ffd2.bones.base.BMethod();
			bonesConstructor_ = new org.ffd2.bones.base.BConstructor();
			bonesConstructor_.setCodeBlock(getConstructorCode());
			bonesConstructor_.setPublic();
		}
		public final ChainBlockFormHolder.ChainBlockFormBlock getPrevious() {
			return previous_;
		}
		public final BaseBuilder getRootBuilder() {
			return parent_;
		}
		public final void setPostConstruction() {
		}
		public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
			if(previous_ != null) {
				previous_.resolutionPass(packageAccess);
			}
			packageAccess.addType(chainBlockClassBonesClass_);
			chainBlockClassBonesClass_.setName(this.getChainNameParameter(), "Chain");
			this.getChainBlockClassBonesClass().addType(linkBonesClass_);
			linkBonesClass_.setName("Link");
			this.getChainBlockClassBonesClass().addInstanceVariable(linkStore_Bones_);
			linkStore_Bones_.setName("linkStore_");
			this.getChainBlockClassBonesClass().addInstanceVariable(index_Bones_);
			index_Bones_.setName("index_");
			this.getChainBlockClassBonesClass().addInstanceMethod(addFromMethod_);
			org.ffd2.bones.base.BParameters parameters = addFromMethod_.getParameters();
			parameters.addParameter(getOtherBonesVariable());
			this.getChainBlockClassBonesClass().addInstanceMethod(clearAllMethod_);
			org.ffd2.bones.base.BParameters parameters_1 = clearAllMethod_.getParameters();
			this.getChainBlockClassBonesClass().addInstanceMethod(getSizeMethod_);
			org.ffd2.bones.base.BParameters parameters_2 = getSizeMethod_.getParameters();
			this.getChainBlockClassBonesClass().addInstanceMethod(updatePeerMethod_);
			org.ffd2.bones.base.BParameters parameters_3 = updatePeerMethod_.getParameters();
			parameters_3.addParameter(getPeerBaseBonesVariable());
			this.getChainBlockClassBonesClass().addInstanceMethod(getChainIndexMethod_);
			org.ffd2.bones.base.BParameters parameters_4 = getChainIndexMethod_.getParameters();
			this.getChainBlockClassBonesClass().addInstanceMethod(markMethod_);
			org.ffd2.bones.base.BParameters parameters_5 = markMethod_.getParameters();
			this.getChainBlockClassBonesClass().addInstanceMethod(unmarkMethod_);
			org.ffd2.bones.base.BParameters parameters_6 = unmarkMethod_.getParameters();
			parameters_6.addParameter(getIndexBonesVariable());
			this.getLinkBonesClass().addInstanceMethod(updateChainMethod_);
			org.ffd2.bones.base.BParameters parameters_7 = updateChainMethod_.getParameters();
			parameters_7.addParameter(getLinkIndexBonesVariable());
			parameters_7.addParameter(getPeerBonesVariable_1());
			this.getChainBlockClassBonesClass().addConstructor(bonesConstructor_);
			org.ffd2.bones.base.BParameters parameters_8 = bonesConstructor_.getParameters();
			parameters_8.addParameter(getTrackerBonesVariable());
			if(linkTypeEnd_ != null) {
				linkTypeEnd_.resolutionPass(packageAccess);
			}
		}
		public final void finish() {
			if(previous_ != null) {
				previous_.finish();
			}
			peerBones_.setName("peer");
			org.ffd2.bones.base.TypeSettable varableType = peerBones_.getTypeSettable();
			varableType.setResultType(getTargetPeerParameter().getChainInterfaceBonesClass());
			linkCountBones_.setName("linkCount");
			org.ffd2.bones.base.TypeSettable varableType_1 = linkCountBones_.getTypeSettable();
			varableType_1.setIntResultType();
			iBones_.setName("i");
			org.ffd2.bones.base.TypeSettable varableType_2 = iBones_.getTypeSettable();
			varableType_2.setIntResultType();
			lBones_.setName("l");
			org.ffd2.bones.base.TypeSettable varableType_3 = lBones_.getTypeSettable();
			varableType_3.setResultType(this.getLinkBonesClass());
			trackerBones_.setName("tracker");
			org.ffd2.bones.base.TypeSettable varableType_4 = trackerBones_.getTypeSettable();
			varableType_4.setResultType(getRelatedTrackerParameter().getParent().getIDTrackerBonesClass());
			otherBones_.setName("other");
			org.ffd2.bones.base.TypeSettable varableType_5 = otherBones_.getTypeSettable();
			varableType_5.setResultType(this.getChainBlockClassBonesClass());
			peerBaseBones_.setName("peerBase");
			org.ffd2.bones.base.TypeSettable varableType_6 = peerBaseBones_.getTypeSettable();
			varableType_6.setResultType(getTargetPeerParameter().getParent().getTargetBaseBonesClass());
			indexBones_.setName("index");
			org.ffd2.bones.base.TypeSettable varableType_7 = indexBones_.getTypeSettable();
			varableType_7.setIntResultType();
			linkIndexBones_.setName("linkIndex");
			org.ffd2.bones.base.TypeSettable varableType_8 = linkIndexBones_.getTypeSettable();
			varableType_8.setIntResultType();
			peerBones_1_.setName("peer");
			org.ffd2.bones.base.TypeSettable varableType_9 = peerBones_1_.getTypeSettable();
			varableType_9.setResultType(getTargetPeerParameter().getChainInterfaceBonesClass());
			addFromMethod_.setName("addFrom");
			org.ffd2.bones.base.TypeSettable returnType = addFromMethod_.getReturnTypeSettable();
			returnType.setVoidResultType();
			clearAllMethod_.setName("clearAll");
			org.ffd2.bones.base.TypeSettable returnType_1 = clearAllMethod_.getReturnTypeSettable();
			returnType_1.setVoidResultType();
			getSizeMethod_.setName("getSize");
			org.ffd2.bones.base.TypeSettable returnType_2 = getSizeMethod_.getReturnTypeSettable();
			returnType_2.setIntResultType();
			updatePeerMethod_.setName("updatePeer");
			org.ffd2.bones.base.TypeSettable returnType_3 = updatePeerMethod_.getReturnTypeSettable();
			returnType_3.setVoidResultType();
			getChainIndexMethod_.setName("getChainIndex");
			org.ffd2.bones.base.TypeSettable returnType_4 = getChainIndexMethod_.getReturnTypeSettable();
			returnType_4.setIntResultType();
			markMethod_.setName("mark");
			org.ffd2.bones.base.TypeSettable returnType_5 = markMethod_.getReturnTypeSettable();
			returnType_5.setIntResultType();
			unmarkMethod_.setName("unmark");
			org.ffd2.bones.base.TypeSettable returnType_6 = unmarkMethod_.getReturnTypeSettable();
			returnType_6.setVoidResultType();
			updateChainMethod_.setName("updateChain");
			org.ffd2.bones.base.TypeSettable returnType_7 = updateChainMethod_.getReturnTypeSettable();
			returnType_7.setVoidResultType();
			org.ffd2.bones.base.TypeSettable varableType_10 = linkStore_Bones_.getTypeSettable();
			varableType_10.setExternalType("org.ffd2.solar.general.SimpleVector");
			org.ffd2.bones.base.TypeSettable genericTarget = varableType_10.addGenerics();
			genericTarget.setResultType(this.getLinkBonesClass());
			org.ffd2.bones.base.TypeSettable varableType_11 = index_Bones_.getTypeSettable();
			varableType_11.setIntResultType();
			org.ffd2.bones.base.BCodeBlock target = getAddFromCode();
			org.ffd2.bones.base.IfBlock ifBlock = target.ifBlock();
			org.ffd2.bones.base.BExpression conditionalExpression = ifBlock.getConditional();
			org.ffd2.bones.base.BExpression right = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression left = new org.ffd2.bones.base.BExpression();
			left.variable(this.getOtherBonesVariable());
			right.setNull();
			conditionalExpression.binary(left, "!=", right);
			org.ffd2.bones.base.BCodeBlock trueBlock = ifBlock.getTrueCode();
			buildIfTrue(trueBlock);
			org.ffd2.bones.base.BCodeBlock target_1 = getClearAllCode();
			org.ffd2.bones.base.BExpression expressionValue = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.CallChain chain = new org.ffd2.bones.base.CallChain();
			chain.chainVariable(this.getLinkStore_BonesVariable());
			expressionValue.callChain(chain);
			org.ffd2.bones.base.CallChain chain_1 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.ArgumentSet methodArguments = chain_1.externalMethodCall("removeAllElements");
			expressionValue.callChain(chain_1);
			target_1.addExpression(expressionValue);
			org.ffd2.bones.base.BCodeBlock target_2 = getGetSizeCode();
			org.ffd2.bones.base.BExpression returnValue = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.CallChain chain_2 = new org.ffd2.bones.base.CallChain();
			chain_2.chainVariable(this.getLinkStore_BonesVariable());
			returnValue.callChain(chain_2);
			org.ffd2.bones.base.CallChain chain_3 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.ArgumentSet methodArguments_1 = chain_3.externalMethodCall("size");
			returnValue.callChain(chain_3);
			target_2.addReturn(returnValue);
			org.ffd2.bones.base.BCodeBlock target_3 = getUpdatePeerCode();
			org.ffd2.bones.base.LocalVariableDeclaration declarationVariable = this.getPeerBonesVariable();
			target_3.addDeclareVariable(declarationVariable);
			org.ffd2.bones.base.BExpression initialValueExpression = declarationVariable.createValue();
			org.ffd2.bones.base.CallChain chain_4 = new org.ffd2.bones.base.CallChain();
			chain_4.chainVariable(this.getPeerBaseBonesVariable());
			initialValueExpression.callChain(chain_4);
			org.ffd2.bones.base.CallChain chain_5 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.MethodCall methodCall = chain_5.chainMethod(getTargetPeerParameter().getGetCreatedBonesMethod());
			org.ffd2.bones.base.ArgumentSet methodArguments_2 = methodCall.getArguments();
			org.ffd2.bones.base.BExpression argument = methodArguments_2.addNewArgument();
			argument.variable(this.getIndex_BonesVariable());
			initialValueExpression.callChain(chain_5);
			org.ffd2.bones.base.LocalVariableDeclaration declarationVariable_1 = this.getLinkCountBonesVariable();
			target_3.addDeclareVariable(declarationVariable_1);
			org.ffd2.bones.base.BExpression initialValueExpression_1 = declarationVariable_1.createValue();
			org.ffd2.bones.base.CallChain chain_6 = new org.ffd2.bones.base.CallChain();
			chain_6.chainVariable(this.getLinkStore_BonesVariable());
			initialValueExpression_1.callChain(chain_6);
			org.ffd2.bones.base.CallChain chain_7 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.ArgumentSet methodArguments_3 = chain_7.externalMethodCall("size");
			initialValueExpression_1.callChain(chain_7);
			org.ffd2.bones.base.ForBlock forBlock = target_3.forBlock();
			org.ffd2.bones.base.BExpression conditionalExpression_1 = forBlock.getTerminateConditional();
			org.ffd2.bones.base.BExpression roundExpression = forBlock.getLoopConditional();
			org.ffd2.bones.base.BExpression right_1 = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression left_1 = new org.ffd2.bones.base.BExpression();
			left_1.variable(this.getIBonesVariable());
			right_1.variable(this.getLinkCountBonesVariable());
			conditionalExpression_1.binary(left_1, "<", right_1);
			org.ffd2.bones.base.BExpression unary = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression unary_1 = new org.ffd2.bones.base.BExpression();
			unary_1.variable(this.getIBonesVariable());
			unary.postUnary(unary_1, "+");
			roundExpression.postUnary(unary, "+");
			org.ffd2.bones.base.LocalVariableDeclaration declarationVariable_2 = this.getIBonesVariable();
			forBlock.addInitialVariable(declarationVariable_2);
			org.ffd2.bones.base.BExpression initialValueExpression_2 = declarationVariable_2.createValue();
			initialValueExpression_2.primitiveInt(0);
			org.ffd2.bones.base.BCodeBlock loopBlock = forBlock.getMainCode();
			buildFor(loopBlock);
			org.ffd2.bones.base.BCodeBlock target_4 = getGetChainIndexCode();
			org.ffd2.bones.base.BExpression returnValue_1 = new org.ffd2.bones.base.BExpression();
			returnValue_1.variable(this.getIndex_BonesVariable());
			target_4.addReturn(returnValue_1);
			org.ffd2.bones.base.BCodeBlock target_5 = getMarkCode();
			org.ffd2.bones.base.BExpression returnValue_2 = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.CallChain chain_8 = new org.ffd2.bones.base.CallChain();
			chain_8.chainVariable(this.getLinkStore_BonesVariable());
			returnValue_2.callChain(chain_8);
			org.ffd2.bones.base.CallChain chain_9 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.ArgumentSet methodArguments_4 = chain_9.externalMethodCall("size");
			returnValue_2.callChain(chain_9);
			target_5.addReturn(returnValue_2);
			org.ffd2.bones.base.BCodeBlock target_6 = getUnmarkCode();
			org.ffd2.bones.base.BExpression expressionValue_1 = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.CallChain chain_10 = new org.ffd2.bones.base.CallChain();
			chain_10.chainVariable(this.getLinkStore_BonesVariable());
			expressionValue_1.callChain(chain_10);
			org.ffd2.bones.base.CallChain chain_11 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.ArgumentSet methodArguments_5 = chain_11.externalMethodCall("deleteFrom");
			org.ffd2.bones.base.BExpression argument_1 = methodArguments_5.addNewArgument();
			argument_1.variable(this.getIndexBonesVariable());
			expressionValue_1.callChain(chain_11);
			target_6.addExpression(expressionValue_1);
			org.ffd2.bones.base.BCodeBlock target_7 = getConstructorCode();
			org.ffd2.bones.base.BExpression expressionValue_2 = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression right_2 = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression left_2 = new org.ffd2.bones.base.BExpression();
			left_2.variable(this.getLinkStore_BonesVariable());
			org.ffd2.bones.base.BConstructorCall constructorCall = right_2.constructorCall();
			org.ffd2.bones.base.TypeSettable targetType = constructorCall.getTypeSettable();
			targetType.setExternalType("org.ffd2.solar.general.SimpleVector");
			org.ffd2.bones.base.TypeSettable genericTarget_1 = targetType.addGenerics();
			genericTarget_1.setResultType(this.getLinkBonesClass());
			expressionValue_2.binary(left_2, "=", right_2);
			target_7.addExpression(expressionValue_2);
			org.ffd2.bones.base.BExpression expressionValue_3 = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression right_3 = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.BExpression left_3 = new org.ffd2.bones.base.BExpression();
			left_3.variable(this.getIndex_BonesVariable());
			org.ffd2.bones.base.CallChain chain_12 = new org.ffd2.bones.base.CallChain();
			chain_12.chainVariable(this.getTrackerBonesVariable());
			right_3.callChain(chain_12);
			org.ffd2.bones.base.CallChain chain_13 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.MethodCall methodCall_1 = chain_13.chainMethod(getRelatedTrackerParameter().getNewIndexBonesMethod());
			right_3.callChain(chain_13);
			expressionValue_3.binary(left_3, "=", right_3);
			target_7.addExpression(expressionValue_3);
			if(linkTypeEnd_ != null) {
				linkTypeEnd_.finish();
			}
		}
		public final BaseBuilder getParent() {
			return parent_;
		}
		public final ChainBlockFormHolder.ChainBlockFormBlock.LinkTypeDataBlock getLinkTypeEnd() {
			return linkTypeEnd_;
		}
		public final ChainBlockFormHolder.ChainBlockFormBlock.LinkTypeDataBlock addLinkType(java.lang.String linkName, DataBlockFormHolder.DataBlockFormBlock linkType, TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock.LinkRefDataBlock linkPeer) {
			ChainBlockFormHolder.ChainBlockFormBlock.LinkTypeDataBlock child = new ChainBlockFormHolder.ChainBlockFormBlock.LinkTypeDataBlock(this, linkName, linkType, linkPeer, linkTypeEnd_);
			linkTypeEnd_ = child;
			return child;
		}
		public final java.lang.String getChainNameParameter() {
			return chainNameParameter_;
		}
		public final IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock getRelatedTrackerParameter() {
			return relatedTrackerParameter_;
		}
		public final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock getTargetPeerParameter() {
			return targetPeerParameter_;
		}
		public final org.ffd2.bones.base.BClass getChainBlockClassBonesClass() {
			return chainBlockClassBonesClass_;
		}
		public final org.ffd2.bones.base.BClass getLinkBonesClass() {
			return linkBonesClass_;
		}
		public final org.ffd2.bones.base.InstanceVariable getLinkStore_BonesVariable() {
			return linkStore_Bones_;
		}
		public final org.ffd2.bones.base.InstanceVariable getIndex_BonesVariable() {
			return index_Bones_;
		}
		public final org.ffd2.bones.base.LocalVariableDeclaration getPeerBonesVariable() {
			return peerBones_;
		}
		public final org.ffd2.bones.base.LocalVariableDeclaration getLinkCountBonesVariable() {
			return linkCountBones_;
		}
		public final org.ffd2.bones.base.LocalVariableDeclaration getIBonesVariable() {
			return iBones_;
		}
		public final org.ffd2.bones.base.LocalVariableDeclaration getLBonesVariable() {
			return lBones_;
		}
		public final org.ffd2.bones.base.ParameterVariable getTrackerBonesVariable() {
			return trackerBones_;
		}
		public final org.ffd2.bones.base.ParameterVariable getOtherBonesVariable() {
			return otherBones_;
		}
		public final org.ffd2.bones.base.ParameterVariable getPeerBaseBonesVariable() {
			return peerBaseBones_;
		}
		public final org.ffd2.bones.base.ParameterVariable getIndexBonesVariable() {
			return indexBones_;
		}
		public final org.ffd2.bones.base.ParameterVariable getLinkIndexBonesVariable() {
			return linkIndexBones_;
		}
		public final org.ffd2.bones.base.ParameterVariable getPeerBonesVariable_1() {
			return peerBones_1_;
		}
		public final org.ffd2.bones.base.BCodeBlock getConstructorCode() {
			return constructorCode_;
		}
		public final org.ffd2.bones.base.BCodeBlock getAddFromCode() {
			return addFromCode_;
		}
		public final org.ffd2.bones.base.BCodeBlock getClearAllCode() {
			return clearAllCode_;
		}
		public final org.ffd2.bones.base.BCodeBlock getGetSizeCode() {
			return getSizeCode_;
		}
		public final org.ffd2.bones.base.BCodeBlock getUpdatePeerCode() {
			return updatePeerCode_;
		}
		public final org.ffd2.bones.base.BCodeBlock getGetChainIndexCode() {
			return getChainIndexCode_;
		}
		public final org.ffd2.bones.base.BCodeBlock getMarkCode() {
			return markCode_;
		}
		public final org.ffd2.bones.base.BCodeBlock getUnmarkCode() {
			return unmarkCode_;
		}
		public final org.ffd2.bones.base.BMethod getAddFromBonesMethod() {
			return addFromMethod_;
		}
		private final void buildIfTrue(org.ffd2.bones.base.BCodeBlock target) {
			org.ffd2.bones.base.BCodeBlock sub = target.createSubBlock();
			org.ffd2.bones.base.BExpression expressionValue = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.CallChain chain = new org.ffd2.bones.base.CallChain();
			chain.chainVariable(this.getLinkStore_BonesVariable());
			expressionValue.callChain(chain);
			org.ffd2.bones.base.CallChain chain_1 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.ArgumentSet methodArguments = chain_1.externalMethodCall("addFrom");
			org.ffd2.bones.base.BExpression argument = methodArguments.addNewArgument();
			org.ffd2.bones.base.CallChain chain_2 = new org.ffd2.bones.base.CallChain();
			chain_2.chainVariable(this.getOtherBonesVariable());
			argument.callChain(chain_2);
			org.ffd2.bones.base.CallChain chain_3 = new org.ffd2.bones.base.CallChain();
			chain_3.chainVariable(this.getLinkStore_BonesVariable());
			argument.callChain(chain_3);
			expressionValue.callChain(chain_1);
			sub.addExpression(expressionValue);
		}
		public final org.ffd2.bones.base.BMethod getClearAllBonesMethod() {
			return clearAllMethod_;
		}
		public final org.ffd2.bones.base.BMethod getGetSizeBonesMethod() {
			return getSizeMethod_;
		}
		public final org.ffd2.bones.base.BMethod getUpdatePeerBonesMethod() {
			return updatePeerMethod_;
		}
		private final void buildFor(org.ffd2.bones.base.BCodeBlock target) {
			org.ffd2.bones.base.BCodeBlock sub = target.createSubBlock();
			org.ffd2.bones.base.LocalVariableDeclaration declarationVariable = this.getLBonesVariable();
			sub.addDeclareVariable(declarationVariable);
			org.ffd2.bones.base.BExpression initialValueExpression = declarationVariable.createValue();
			org.ffd2.bones.base.CallChain chain = new org.ffd2.bones.base.CallChain();
			chain.chainVariable(this.getLinkStore_BonesVariable());
			initialValueExpression.callChain(chain);
			org.ffd2.bones.base.CallChain chain_1 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.ArgumentSet methodArguments = chain_1.externalMethodCall("get");
			org.ffd2.bones.base.BExpression argument = methodArguments.addNewArgument();
			argument.variable(this.getIBonesVariable());
			initialValueExpression.callChain(chain_1);
			org.ffd2.bones.base.BExpression expressionValue = new org.ffd2.bones.base.BExpression();
			org.ffd2.bones.base.CallChain chain_2 = new org.ffd2.bones.base.CallChain();
			chain_2.chainVariable(this.getLBonesVariable());
			expressionValue.callChain(chain_2);
			org.ffd2.bones.base.CallChain chain_3 = new org.ffd2.bones.base.CallChain();
			org.ffd2.bones.base.MethodCall methodCall = chain_3.chainMethod(this.getUpdateChainBonesMethod());
			org.ffd2.bones.base.ArgumentSet methodArguments_1 = methodCall.getArguments();
			org.ffd2.bones.base.BExpression argument_1 = methodArguments_1.addNewArgument();
			argument_1.variable(this.getIBonesVariable());
			org.ffd2.bones.base.BExpression argument_2 = methodArguments_1.addNewArgument();
			argument_2.variable(this.getPeerBonesVariable());
			expressionValue.callChain(chain_3);
			sub.addExpression(expressionValue);
		}
		public final org.ffd2.bones.base.BMethod getGetChainIndexBonesMethod() {
			return getChainIndexMethod_;
		}
		public final org.ffd2.bones.base.BMethod getMarkBonesMethod() {
			return markMethod_;
		}
		public final org.ffd2.bones.base.BMethod getUnmarkBonesMethod() {
			return unmarkMethod_;
		}
		public final org.ffd2.bones.base.BMethod getUpdateChainBonesMethod() {
			return updateChainMethod_;
		}
		public static final class LinkTypeDataBlock {
			private final ChainBlockFormHolder.ChainBlockFormBlock.LinkTypeDataBlock previous_;
			public ChainBlockFormHolder.ChainBlockFormBlock parent_;
			private final java.lang.String linkNameParameter_;
			private final DataBlockFormHolder.DataBlockFormBlock linkTypeParameter_;
			private final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock.LinkRefDataBlock linkPeerParameter_;
			private org.ffd2.bones.base.BClass linkValueBonesClass_;
			private org.ffd2.bones.base.InstanceVariable value_Bones_;
			private final org.ffd2.bones.base.ParameterVariable valueBones_;
			private final org.ffd2.bones.base.ParameterVariable valueBones_1_;
			private final org.ffd2.bones.base.ParameterVariable linkIndexBones_;
			private final org.ffd2.bones.base.ParameterVariable peerBones_;
			private final org.ffd2.bones.base.BCodeBlock constructorCode_;
			private final org.ffd2.bones.base.BCodeBlock addLinkCode_;
			private final org.ffd2.bones.base.BCodeBlock updateChainCode_;
			private org.ffd2.bones.base.BMethod addLinkMethod_;
			private org.ffd2.bones.base.BMethod updateChainMethod_;
			private final org.ffd2.bones.base.BConstructor bonesConstructor_;
			public LinkTypeDataBlock(ChainBlockFormHolder.ChainBlockFormBlock parent, java.lang.String linkName, DataBlockFormHolder.DataBlockFormBlock linkType, TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock.LinkRefDataBlock linkPeer, ChainBlockFormHolder.ChainBlockFormBlock.LinkTypeDataBlock previous) {
				previous_ = previous;
				linkNameParameter_ = linkName;
				linkTypeParameter_ = linkType;
				linkPeerParameter_ = linkPeer;
				parent_ = parent;
				linkValueBonesClass_ = new org.ffd2.bones.base.BClass(true);
				value_Bones_ = new org.ffd2.bones.base.InstanceVariable();
				valueBones_ = new org.ffd2.bones.base.ParameterVariable();
				valueBones_1_ = new org.ffd2.bones.base.ParameterVariable();
				linkIndexBones_ = new org.ffd2.bones.base.ParameterVariable();
				peerBones_ = new org.ffd2.bones.base.ParameterVariable();
				constructorCode_ = new org.ffd2.bones.base.BCodeBlock();
				addLinkCode_ = new org.ffd2.bones.base.BCodeBlock();
				updateChainCode_ = new org.ffd2.bones.base.BCodeBlock();
				addLinkMethod_ = new org.ffd2.bones.base.BMethod();
				addLinkMethod_.setCodeBlock(getAddLinkCode());
				updateChainMethod_ = new org.ffd2.bones.base.BMethod();
				updateChainMethod_.setCodeBlock(getUpdateChainCode());
				bonesConstructor_ = new org.ffd2.bones.base.BConstructor();
				bonesConstructor_.setCodeBlock(getConstructorCode());
				bonesConstructor_.setPublic();
			}
			public final ChainBlockFormHolder.ChainBlockFormBlock.LinkTypeDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				getParent().getChainBlockClassBonesClass().addType(linkValueBonesClass_);
				linkValueBonesClass_.setName(this.getLinkNameParameter(), "LinkValue");
				this.getLinkValueBonesClass().addInstanceVariable(value_Bones_);
				value_Bones_.setName("value_");
				getParent().getChainBlockClassBonesClass().addInstanceMethod(addLinkMethod_);
				org.ffd2.bones.base.BParameters parameters = addLinkMethod_.getParameters();
				parameters.addParameter(getValueBonesVariable());
				this.getLinkValueBonesClass().addInstanceMethod(updateChainMethod_);
				org.ffd2.bones.base.BParameters parameters_1 = updateChainMethod_.getParameters();
				parameters_1.addParameter(getLinkIndexBonesVariable());
				parameters_1.addParameter(getPeerBonesVariable());
				this.getLinkValueBonesClass().addConstructor(bonesConstructor_);
				org.ffd2.bones.base.BParameters parameters_2 = bonesConstructor_.getParameters();
				parameters_2.addParameter(getValueBonesVariable_1());
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				valueBones_.setName("value");
				org.ffd2.bones.base.TypeSettable varableType = valueBones_.getTypeSettable();
				varableType.setResultType(getLinkTypeParameter().getDataClassBonesClass());
				valueBones_1_.setName("value");
				org.ffd2.bones.base.TypeSettable varableType_1 = valueBones_1_.getTypeSettable();
				varableType_1.setResultType(getLinkTypeParameter().getDataClassBonesClass());
				linkIndexBones_.setName("linkIndex");
				org.ffd2.bones.base.TypeSettable varableType_2 = linkIndexBones_.getTypeSettable();
				varableType_2.setIntResultType();
				peerBones_.setName("peer");
				org.ffd2.bones.base.TypeSettable varableType_3 = peerBones_.getTypeSettable();
				varableType_3.setResultType(getLinkPeerParameter().getParent().getChainInterfaceBonesClass());
				addLinkMethod_.setName("add", this.getLinkNameParameter(), "Link");
				org.ffd2.bones.base.TypeSettable returnType = addLinkMethod_.getReturnTypeSettable();
				returnType.setVoidResultType();
				updateChainMethod_.setName("updateChain");
				org.ffd2.bones.base.TypeSettable returnType_1 = updateChainMethod_.getReturnTypeSettable();
				returnType_1.setVoidResultType();
				org.ffd2.bones.base.TypeSettable varableType_4 = value_Bones_.getTypeSettable();
				varableType_4.setResultType(getLinkTypeParameter().getDataClassBonesClass());
				org.ffd2.bones.base.TypeList implementsList = linkValueBonesClass_.getImplementsList();
				org.ffd2.bones.base.TypeSettable newType = implementsList.newGeneral();
				newType.setResultType(getParent().getLinkBonesClass());
				org.ffd2.bones.base.BCodeBlock target = getAddLinkCode();
				org.ffd2.bones.base.BExpression expressionValue = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.CallChain chain = new org.ffd2.bones.base.CallChain();
				chain.chainVariable(getParent().getLinkStore_BonesVariable());
				expressionValue.callChain(chain);
				org.ffd2.bones.base.CallChain chain_1 = new org.ffd2.bones.base.CallChain();
				org.ffd2.bones.base.ArgumentSet methodArguments = chain_1.externalMethodCall("addElement");
				org.ffd2.bones.base.BExpression argument = methodArguments.addNewArgument();
				org.ffd2.bones.base.BConstructorCall constructorCall = argument.constructorCall();
				org.ffd2.bones.base.TypeSettable targetType = constructorCall.getTypeSettable();
				targetType.setResultType(this.getLinkValueBonesClass());
				org.ffd2.bones.base.ArgumentSet constructorArguments = constructorCall.getArgumentSet();
				org.ffd2.bones.base.BExpression argument_1 = constructorArguments.addNewArgument();
				argument_1.variable(this.getValueBonesVariable());
				expressionValue.callChain(chain_1);
				target.addExpression(expressionValue);
				org.ffd2.bones.base.BCodeBlock target_1 = getUpdateChainCode();
				org.ffd2.bones.base.BExpression expressionValue_1 = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.CallChain chain_2 = new org.ffd2.bones.base.CallChain();
				chain_2.chainVariable(this.getPeerBonesVariable());
				expressionValue_1.callChain(chain_2);
				org.ffd2.bones.base.CallChain chain_3 = new org.ffd2.bones.base.CallChain();
				org.ffd2.bones.base.MethodCall methodCall = chain_3.chainMethod(getLinkPeerParameter().getAddLinkBonesMethod());
				org.ffd2.bones.base.ArgumentSet methodArguments_1 = methodCall.getArguments();
				org.ffd2.bones.base.BExpression argument_2 = methodArguments_1.addNewArgument();
				argument_2.variable(this.getLinkIndexBonesVariable());
				org.ffd2.bones.base.BExpression argument_3 = methodArguments_1.addNewArgument();
				org.ffd2.bones.base.CallChain chain_4 = new org.ffd2.bones.base.CallChain();
				chain_4.chainVariable(this.getValue_BonesVariable());
				argument_3.callChain(chain_4);
				org.ffd2.bones.base.CallChain chain_5 = new org.ffd2.bones.base.CallChain();
				org.ffd2.bones.base.MethodCall methodCall_1 = chain_5.chainMethod(getLinkTypeParameter().getGetIndexBonesMethod());
				argument_3.callChain(chain_5);
				expressionValue_1.callChain(chain_3);
				target_1.addExpression(expressionValue_1);
				org.ffd2.bones.base.BCodeBlock target_2 = getConstructorCode();
				org.ffd2.bones.base.BExpression expressionValue_2 = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.BExpression right = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.BExpression left = new org.ffd2.bones.base.BExpression();
				left.variable(this.getValue_BonesVariable());
				right.variable(this.getValueBonesVariable_1());
				expressionValue_2.binary(left, "=", right);
				target_2.addExpression(expressionValue_2);
			}
			public final ChainBlockFormHolder.ChainBlockFormBlock getParent() {
				return parent_;
			}
			public final java.lang.String getLinkNameParameter() {
				return linkNameParameter_;
			}
			public final DataBlockFormHolder.DataBlockFormBlock getLinkTypeParameter() {
				return linkTypeParameter_;
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock.ChainDataBlock.LinkRefDataBlock getLinkPeerParameter() {
				return linkPeerParameter_;
			}
			public final org.ffd2.bones.base.BClass getLinkValueBonesClass() {
				return linkValueBonesClass_;
			}
			public final org.ffd2.bones.base.InstanceVariable getValue_BonesVariable() {
				return value_Bones_;
			}
			public final org.ffd2.bones.base.ParameterVariable getValueBonesVariable() {
				return valueBones_;
			}
			public final org.ffd2.bones.base.ParameterVariable getValueBonesVariable_1() {
				return valueBones_1_;
			}
			public final org.ffd2.bones.base.ParameterVariable getLinkIndexBonesVariable() {
				return linkIndexBones_;
			}
			public final org.ffd2.bones.base.ParameterVariable getPeerBonesVariable() {
				return peerBones_;
			}
			public final org.ffd2.bones.base.BCodeBlock getConstructorCode() {
				return constructorCode_;
			}
			public final org.ffd2.bones.base.BCodeBlock getAddLinkCode() {
				return addLinkCode_;
			}
			public final org.ffd2.bones.base.BCodeBlock getUpdateChainCode() {
				return updateChainCode_;
			}
			public final org.ffd2.bones.base.BMethod getAddLinkBonesMethod() {
				return addLinkMethod_;
			}
			public final org.ffd2.bones.base.BMethod getUpdateChainBonesMethod() {
				return updateChainMethod_;
			}
		}
	}
}
