package org.ffd2.skeletonx.skeleton;
public final class TypeListDetailsFormHolder {
	public static final class TypeListDetailsFormBlock {
		private final TypeListDetailsFormHolder.TypeListDetailsFormBlock previous_;
		public BaseBuilder parent_;
		public TypeListDetailsFormHolder.TypeListDetailsFormBlock.SimpleDataBlock simpleEnd_ = null;
		public TypeListDetailsFormHolder.TypeListDetailsFormBlock.LinkedDataBlock linkedEnd_ = null;
		public TypeListDetailsFormBlock(BaseBuilder parent, TypeListDetailsFormHolder.TypeListDetailsFormBlock previous) {
			previous_ = previous;
			parent_ = parent;
		}
		public final TypeListDetailsFormHolder.TypeListDetailsFormBlock getPrevious() {
			return previous_;
		}
		public final BaseBuilder getRootBuilder() {
			return parent_;
		}
		public final void setPostConstruction() {
		}
		public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
			if(previous_ != null) {
				previous_.resolutionPass(packageAccess);
			}
			if(simpleEnd_ != null) {
				simpleEnd_.resolutionPass(packageAccess);
			}
			if(linkedEnd_ != null) {
				linkedEnd_.resolutionPass(packageAccess);
			}
		}
		public final void finish() {
			if(previous_ != null) {
				previous_.finish();
			}
			if(simpleEnd_ != null) {
				simpleEnd_.finish();
			}
			if(linkedEnd_ != null) {
				linkedEnd_.finish();
			}
		}
		public final BaseBuilder getParent() {
			return parent_;
		}
		public final TypeListDetailsFormHolder.TypeListDetailsFormBlock.SimpleDataBlock getSimpleEnd() {
			return simpleEnd_;
		}
		public final TypeListDetailsFormHolder.TypeListDetailsFormBlock.SimpleDataBlock addSimple(TypeSetterDetailsFormHolder.TypeSetterDetailsFormBlock typeDetails) {
			TypeListDetailsFormHolder.TypeListDetailsFormBlock.SimpleDataBlock child = new TypeListDetailsFormHolder.TypeListDetailsFormBlock.SimpleDataBlock(this, typeDetails, simpleEnd_);
			simpleEnd_ = child;
			return child;
		}
		public final TypeListDetailsFormHolder.TypeListDetailsFormBlock.LinkedDataBlock getLinkedEnd() {
			return linkedEnd_;
		}
		public final TypeListDetailsFormHolder.TypeListDetailsFormBlock.LinkedDataBlock addLinked(TypeListAccessFormHolder.TypeListAccessFormBlock parentList, BaseTrackers.JavaVariablePath pathToParentList) {
			TypeListDetailsFormHolder.TypeListDetailsFormBlock.LinkedDataBlock child = new TypeListDetailsFormHolder.TypeListDetailsFormBlock.LinkedDataBlock(this, parentList, pathToParentList, linkedEnd_);
			linkedEnd_ = child;
			return child;
		}
		public static final class SimpleDataBlock {
			private final TypeListDetailsFormHolder.TypeListDetailsFormBlock.SimpleDataBlock previous_;
			public TypeListDetailsFormHolder.TypeListDetailsFormBlock parent_;
			private final TypeSetterDetailsFormHolder.TypeSetterDetailsFormBlock typeDetailsParameter_;
			public SimpleDataBlock(TypeListDetailsFormHolder.TypeListDetailsFormBlock parent, TypeSetterDetailsFormHolder.TypeSetterDetailsFormBlock typeDetails, TypeListDetailsFormHolder.TypeListDetailsFormBlock.SimpleDataBlock previous) {
				previous_ = previous;
				typeDetailsParameter_ = typeDetails;
				parent_ = parent;
			}
			public final TypeListDetailsFormHolder.TypeListDetailsFormBlock.SimpleDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
			}
			public final TypeListDetailsFormHolder.TypeListDetailsFormBlock getParent() {
				return parent_;
			}
			public final TypeSetterDetailsFormHolder.TypeSetterDetailsFormBlock getTypeDetailsParameter() {
				return typeDetailsParameter_;
			}
		}
		public static final class LinkedDataBlock {
			private final TypeListDetailsFormHolder.TypeListDetailsFormBlock.LinkedDataBlock previous_;
			public TypeListDetailsFormHolder.TypeListDetailsFormBlock parent_;
			private final TypeListAccessFormHolder.TypeListAccessFormBlock parentListParameter_;
			private final BaseTrackers.JavaVariablePath pathToParentListParameter_;
			public LinkedDataBlock(TypeListDetailsFormHolder.TypeListDetailsFormBlock parent, TypeListAccessFormHolder.TypeListAccessFormBlock parentList, BaseTrackers.JavaVariablePath pathToParentList, TypeListDetailsFormHolder.TypeListDetailsFormBlock.LinkedDataBlock previous) {
				previous_ = previous;
				parentListParameter_ = parentList;
				pathToParentListParameter_ = pathToParentList;
				parent_ = parent;
			}
			public final TypeListDetailsFormHolder.TypeListDetailsFormBlock.LinkedDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
			}
			public final TypeListDetailsFormHolder.TypeListDetailsFormBlock getParent() {
				return parent_;
			}
			public final TypeListAccessFormHolder.TypeListAccessFormBlock getParentListParameter() {
				return parentListParameter_;
			}
			public final BaseTrackers.JavaVariablePath getPathToParentListParameter() {
				return pathToParentListParameter_;
			}
		}
	}
}
