package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
import austenx.general.lexi.tokens.*;
public final class ImportReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 0;
	private final SkeletonPackrat basePackrat_;
	public ImportReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = decodeImport(result, c, 0);
		if(width > 0) {
			result.setDetails(width, 0, 0);
			return oldElement.getImprovedByOrNull(result);
		}
		return null;
	}
	public final int decodeImport(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		SkeletonToken token = c.getColumnToken(newOffset);
		if(!token.isIMPORT_KEYWORD()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		result.mark();
		int checkOffset = maybeSub(result, c, newOffset);
		if(checkOffset < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset;
			result.removeLastMark();
		}
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(2, token_1);
		result.mark();
		int checkOffset_1 = maybeSub_1(result, c, newOffset);
		if(checkOffset_1 < 0) {
			result.undoToMark();
		} else {
			newOffset = checkOffset_1;
			result.removeLastMark();
		}
		boolean found = false;
		result.mark();
		if(!found) {
			int checkOffset_2 = itemSub(result, c, newOffset);
			if(checkOffset_2 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_2;
				result.removeLastMark();
				found = true;
			}
		}
		result.mark();
		if(!found) {
			int checkOffset_3 = itemSub_1(result, c, newOffset);
			if(checkOffset_3 < 0) {
				result.undoToMark();
			} else {
				newOffset = checkOffset_3;
				result.removeLastMark();
				found = true;
			}
		}
		if(!found) {
			return -1;
		}
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isSEMI_COLON_SYMBOL()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int maybeSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isSTAR_SYMBOL()) {
			return -1;
		}
		result.addSubToken(1, token);
		newOffset++;
		return newOffset;
	}
	public final int maybeSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isASSIGNMENT()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int itemSub(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 2).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int itemSub_1(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isSTRING()) {
			return -1;
		}
		result.addSubToken(3, token);
		newOffset++;
		return newOffset;
	}
}
