package org.ffd2.skeletonx.austenx.packrat.impl;
import org.ffd2.skeletonx.austenx.packrat.library.*;
import austenx.general.lexi.tokens.*;
import org.ffd2.skeletonx.austenx.lexi.tokens.*;
public final class MacroCallParameterReader implements SkeletonPackrat.BaseReader {
	private final int rULE_INDEX_ = 39;
	private final SkeletonPackrat basePackrat_;
	public MacroCallParameterReader(SkeletonPackrat basePackrat) {
		basePackrat_ = basePackrat;
	}
	public final org.ffd2.austenx.runtime.PackratElement build(SkeletonPackrat.Column c, org.ffd2.austenx.runtime.PackratElement oldElement) {
		org.ffd2.austenx.runtime.ResolvedPackratElement result = new org.ffd2.austenx.runtime.ResolvedPackratElement();
		int width = 0;
		result.mark();
		width = decodeTargetVariableForMacroCallParameter(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 0, 39);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeThisBasedForMacroCallParameter(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 1, 39);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeStringBasedForMacroCallParameter(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 2, 39);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		result.mark();
		width = decodeIntBasedForMacroCallParameter(result, c, 0);
		if(width > 0) {
			result.removeLastMark();
			result.setDetails(width, 3, 39);
			return oldElement.getImprovedByOrNull(result);
		} else {
			result.undoToMark();
		}
		return null;
	}
	public final int decodeTargetVariableForMacroCallParameter(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isASSIGNMENT()) {
			return -1;
		}
		newOffset++;
		org.ffd2.austenx.runtime.ResolvedPackratElement rule = c.getResult(newOffset, 27).getResolved();
		if(rule == null) {
			return -1;
		}
		newOffset += rule.getWidth();
		result.addSubNode(0, rule);
		return newOffset;
	}
	public final int decodeThisBasedForMacroCallParameter(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isASSIGNMENT()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isDOLLAR_SYMBOL()) {
			return -1;
		}
		newOffset++;
		SkeletonToken token_3 = c.getColumnToken(newOffset);
		if(!token_3.isTHIS_KEYWORD()) {
			return -1;
		}
		newOffset++;
		return newOffset;
	}
	public final int decodeStringBasedForMacroCallParameter(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isASSIGNMENT()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isSTRING()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(1, token_2);
		return newOffset;
	}
	public final int decodeIntBasedForMacroCallParameter(org.ffd2.austenx.runtime.ResolvedPackratElement result, SkeletonPackrat.Column c, int baseCurrentOffset) {
		int newOffset = baseCurrentOffset;
		BasicTokensToken token = c.getColumnToken(newOffset);
		if(!token.isID()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(0, token);
		BasicTokensToken token_1 = c.getColumnToken(newOffset);
		if(!token_1.isASSIGNMENT()) {
			return -1;
		}
		newOffset++;
		BasicTokensToken token_2 = c.getColumnToken(newOffset);
		if(!token_2.isINTEGER()) {
			return -1;
		}
		newOffset++;
		result.addBaseArgument(1, token_2);
		return newOffset;
	}
}
