package org.ffd2.skeletonx.austenx.peg.base;
import org.ffd2.skeletonx.austenx.packrat.impl.*;
public final class DeferredJavaClassInterfaceElementImpl implements DeferredJavaClassInterfaceElement {
	private final org.ffd2.austenx.runtime.ResolvedPackratElement myElement_;
	public DeferredJavaClassInterfaceElementImpl(org.ffd2.austenx.runtime.ResolvedPackratElement myElement) {
		myElement_ = myElement;
	}
	public final void buildJavaClassInterfaceElement(JavaClassInterfaceElementPeer.Indirect target) {
		final org.ffd2.austenx.runtime.ResolvedPackratElement element = myElement_;
		int type = element.getType();
		if(type == 0) {
			JavaClassInterfaceElementPeer.PrototypePatternPeer child = target.createPrototype();
			if(child != null) {
				element.updateConstruction(new AllDecodersSkeleton.PrototypeDecoder(child));
				child.end();
			}
		}
		if(type == 1) {
			JavaClassInterfaceElementPeer.MethodPatternPeer child_1 = target.createMethod();
			if(child_1 != null) {
				element.updateConstruction(new AllDecodersSkeleton.MethodDecoder_1(child_1));
				child_1.end();
			}
		}
		if(type == 2) {
			JavaClassInterfaceElementPeer.ConstructorPatternPeer child_2 = target.createConstructor();
			if(child_2 != null) {
				element.updateConstruction(new AllDecodersSkeleton.ConstructorDecoder(child_2));
				child_2.end();
			}
		}
		if(type == 3) {
			JavaClassInterfaceElementPeer.InstanceVariablePatternPeer child_3 = target.createInstanceVariable();
			if(child_3 != null) {
				element.updateConstruction(new AllDecodersSkeleton.InstanceVariableDecoder(child_3));
				child_3.end();
			}
		}
		if(type == 4) {
			JavaClassInterfaceElementPeer.ClassPatternPeer child_4 = target.createClass();
			if(child_4 != null) {
				element.updateConstruction(new AllDecodersSkeleton.ClassDecoder_1(child_4));
				child_4.end();
			}
		}
		if(type == 5) {
			JavaClassInterfaceElementPeer.InterfacePatternPeer child_5 = target.createInterface();
			if(child_5 != null) {
				element.updateConstruction(new AllDecodersSkeleton.InterfaceDecoder_1(child_5));
				child_5.end();
			}
		}
		if(type == 6) {
			JavaClassInterfaceElementPeer.MacroDefPatternPeer child_6 = target.createMacroDef();
			if(child_6 != null) {
				element.updateConstruction(new AllDecodersSkeleton.MacroDefDecoder_1(child_6));
				child_6.end();
			}
		}
		if(type == 7) {
			JavaClassInterfaceElementPeer.MacroCallPatternPeer child_7 = target.createMacroCall();
			if(child_7 != null) {
				element.updateConstruction(new AllDecodersSkeleton.MacroCallDecoder_1(child_7));
				child_7.end();
			}
		}
		if(type == 8) {
			org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
			JavaClassInterfaceElementPeer.LinkPatternPeer child_8 = target.createLink(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
			if(child_8 != null) {
				element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_1(child_8));
				child_8.end();
			}
		}
		if(type == 9) {
			JavaClassInterfaceElementPeer.FindPatternPeer child_9 = target.createFind();
			if(child_9 != null) {
				element.updateConstruction(new AllDecodersSkeleton.FindDecoder_1(child_9));
				child_9.end();
			}
		}
		if(type == 10) {
			JavaClassInterfaceElementPeer.GlobalClassPatternPeer child_10 = target.createGlobalClass();
			if(child_10 != null) {
				element.updateConstruction(new AllDecodersSkeleton.GlobalClassDecoder_1(child_10));
				child_10.end();
			}
		}
	}
}
