package org.ffd2.skeletonx.austenx.peg.base;
import org.ffd2.skeletonx.austenx.packrat.impl.*;
public final class DeferredTargetCallComponentImpl implements DeferredTargetCallComponent {
	private final org.ffd2.austenx.runtime.ResolvedPackratElement myElement_;
	public DeferredTargetCallComponentImpl(org.ffd2.austenx.runtime.ResolvedPackratElement myElement) {
		myElement_ = myElement;
	}
	public final void buildTargetCallComponent(TargetCallComponentPeer.Indirect target) {
		final org.ffd2.austenx.runtime.ResolvedPackratElement element = myElement_;
		int type = element.getType();
		if(type == 0) {
			org.ffd2.austenx.runtime.BaseToken markNameToken = element.getBaseArgumentToken(0);
			target.createMark(markNameToken.getStringValue(), markNameToken.getLineNumber(), markNameToken.getCharacterNumber());
		}
		if(type == 1) {
			TargetCallComponentPeer.BasicPatternPeer child = target.createBasic();
			if(child != null) {
				element.updateConstruction(new AllDecodersSkeleton.BasicDecoder(child));
				child.end();
			}
		}
		if(type == 2) {
			org.ffd2.austenx.runtime.BaseToken keywordToken = element.getBaseArgumentToken(0);
			TargetCallComponentPeer.LinkPatternPeer child_1 = target.createLink(keywordToken.getLineNumber(), keywordToken.getCharacterNumber());
			if(child_1 != null) {
				element.updateConstruction(new AllDecodersSkeleton.LinkDecoder_3(child_1));
				child_1.end();
			}
		}
	}
}
