package org.ffd2.skeletonx.austenx.peg.base;
public final class MacroElementPeer {
	public static interface Indirect {
		public MacroElementPeer.ArgValsBlockPatternPeer createArgValsBlock() ;
		public MacroElementPeer.ArgTypesBlockPatternPeer createArgTypesBlock() ;
		public MacroElementPeer.CodeBlockPatternPeer createCodeBlock(int keywordLine, int keywordCharacter) ;
		public MacroElementPeer.ContextBlockPatternPeer createContextBlock(int keywordLine, int keywordCharacter) ;
		public MacroElementPeer.ContainerBlockPatternPeer createContainerBlock(int keywordLine, int keywordCharacter) ;
	}
	public static interface ArgValsBlockPatternPeer {
		public void end() ;
		public ArgValsBlockBasePatternPeer addArgValsBlockBaseForBlock(java.lang.String givenCodeVariableName, int givenCodeVariableNameLine, int givenCodeVariableNameCharacter) ;
	}
	public static interface ArgTypesBlockPatternPeer {
		public void end() ;
		public ArgTypesBlockBasePatternPeer addArgTypesBlockBaseForBlock(java.lang.String givenCodeVariableName, int givenCodeVariableNameLine, int givenCodeVariableNameCharacter) ;
	}
	public static interface CodeBlockPatternPeer {
		public void end() ;
		public void addGivenCodeVariableName(java.lang.String value, int lineNumber, int characterNumber) ;
		public ArgTypesBlockBasePatternPeer addArgTypesBlockBaseForParametersBlock(java.lang.String givenCodeVariableName, int givenCodeVariableNameLine, int givenCodeVariableNameCharacter) ;
		public JavaStatementPeer.Indirect getJavaStatementForStatement() ;
		public ArgValsBlockBasePatternPeer addArgValsBlockBaseForBlock(java.lang.String givenCodeVariableName, int givenCodeVariableNameLine, int givenCodeVariableNameCharacter) ;
	}
	public static interface ContextBlockPatternPeer {
		public void end() ;
		public void addExternalTypeName(java.lang.String value) ;
		public JavaClassInterfaceElementPeer.Indirect getJavaClassInterfaceElementForElements() ;
	}
	public static interface ContainerBlockPatternPeer {
		public void end() ;
		public JavaClassInterfaceElementPeer.Indirect getJavaClassInterfaceElementForElements() ;
	}
}
