package org.ffd2.skeletonx.austenx.peg.base;
public final class MacroParameterPeer {
	public static interface Indirect {
		public MacroParameterPeer.RecordPatternPeer createRecord(java.lang.String name, int nameLine, int nameCharacter) ;
		public MacroParameterPeer.VarPatternPeer createVar(java.lang.String name, int nameLine, int nameCharacter) ;
		public MacroParameterPeer.TargetPatternPeer createTarget(java.lang.String name, int nameLine, int nameCharacter) ;
		public void createCodeReference(java.lang.String variableName, int variableNameLine, int variableNameCharacter) ;
		public void createArgValuesReference(java.lang.String variableName, int variableNameLine, int variableNameCharacter) ;
		public void createArgTypesReference(java.lang.String variableName, int variableNameLine, int variableNameCharacter) ;
		public void createChain(int keywordLine, int keywordCharacter, java.lang.String chainName, java.lang.String variableName) ;
		public void createMapping(int keywordLine, int keywordCharacter, java.lang.String mappingName, java.lang.String variableName) ;
		public void createClassReference(java.lang.String name, int nameLine, int nameCharacter) ;
		public void createKey(int keywordLine, int keywordCharacter, java.lang.String keyName, java.lang.String variableName) ;
	}
	public static interface RecordPatternPeer {
		public void end() ;
		public void addTypeElement(java.lang.String value, int lineNumber, int characterNumber) ;
	}
	public static interface VarPatternPeer {
		public void end() ;
		public TargetTypeReferencePatternPeer addTargetTypeReferenceForType(java.lang.String typeName, int typeNameLine, int typeNameCharacter) ;
	}
	public static interface TargetPatternPeer {
		public void end() ;
		public TargetTypeReferencePatternPeer addTargetTypeReferenceForType(java.lang.String typeName, int typeNameLine, int typeNameCharacter) ;
	}
}
