package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.skeleton.BaseBuilder;

import org.ffd2.skeletonx.skeleton.ArgumentSetDetailsFormHolder.ArgumentSetDetailsFormBlock;
import org.ffd2.skeletonx.skeleton.BasicCallChainFormHolder.BasicCallChainFormBlock;
import org.ffd2.skeletonx.skeleton.ExpressionDetailsFormHolder.ExpressionDetailsFormBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MethodDataBlock;
import org.ffd2.skeletonx.skeleton.JavaImplementationFormHolder.JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MethodDataBlock.ImplementsNameDataBlock;
import org.ffd2.skeletonx.skeleton.TypeSetterDetailsFormHolder.TypeSetterDetailsFormBlock;
import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;
import org.ffd2.solar.exceptions.ParsingException;
import org.ffd2.solar.general.Debug;

public class DummyItems {
  public static final TargetType DUMMY_TARGET_TYPE = new TargetType() {
    public DirectTargetElementAccess getDirectElementAccessQuiet() { return null; }
    public TargetType specifyGenericTypes(TargetTypeWithPath[] types) throws ParsingException {
  		return this;
  	}
    public TargetType getArrayed(int dimensions) throws ParsingException {
  		return new ArrayedTargetType(this,dimensions);
  	}
		public boolean isSubTypeOf(TargetType parentType) {
			return parentType==this;
		}
    public String getOutputName() { return "[DUMMY]"; }
   
		public void buildCodeSetType(TypeSetterDetailsFormBlock target, JavaVariablePath disposableTargetPath) { 	}
  };
  public static final TargetMethod DUMMY_TARGET_METHOD = new TargetMethod() {
    public ArgumentSetDetailsFormBlock createExpressionFinal(ExpressionDetailsFormBlock target, JavaVariablePath basePathDisposable) {
      return null;
    }
    public ArgumentSetDetailsFormBlock createCallExpressionFinal(BasicCallChainFormBlock target, JavaVariablePath basePathDisposable) {
    	return null;
    }
    public boolean isStatic() {
    	return false;
    }

    public TargetTypeReference getReturnTargetTypeReferenceQuietFinal() {      return null;  }
		public GlobalMethodReference getAsGlobalQuiet() { return null; }
		public ImplementsNameDataBlock addMethodImplementsNameBlock(MethodDataBlock target, JavaVariablePath methodDeclarationPathChainTracker) throws ParsingException {
			throw ParsingException.createGeneralSyntax("Dummy method cannot provide source for implementation (...)");

		}
  };
  
  public static final TargetVariable DUMMY_TARGET_VARIABLE = new TargetVariable() {
    public void createCallExpressionFinal(BasicCallChainFormBlock target, BaseTrackers.JavaVariablePath basePathDisposable) {}
    public TargetTypeReference getTargetTypeReferenceQuietFinal() {
      return null;
    }
    public void createMacroCallParameter(JavaImplementationFormBlock.BlockDataBlock.ItemDataBlock.MacroCallDataBlock macroCallBlock, 	JavaVariablePath pathToVariable) {
    	Debug.println("EH?");
		}
    
  };

}
