package org.ffd2.skeletonx.compile.java;

public final class MethodAccess {
  private final TargetMethod method_;
  private final TargetElementAccess elementAccess_;
  public MethodAccess(TargetMethod method, TargetElementAccess elementAccess) {
    this.method_ = method;
    this.elementAccess_ = elementAccess;
  }
  public TargetMethod getMethod() {
    return this.method_;
  }
  public TargetElementAccess getElementAccess() {
    return this.elementAccess_; 
  }
}
