package org.ffd2.skeletonx.compile.java;

import org.ffd2.skeletonx.skeleton.BaseTrackers;
import org.ffd2.skeletonx.skeleton.BaseTrackers.JavaVariablePath;

//Target type with possible extra environment stuff

//I don't get the PoolUpdate lark. Once shifted to new version, hopefully can remove, and then shift reliance on DataBlockEnvironment stuff (with target variables and methods?)

public class TargetTypeReference {
	private final TargetType baseType_;

	private PoolUpdater poolUpdater_ = null;
	public TargetTypeReference(TargetType baseType) {
		this.baseType_ = baseType;
	}
	public void updateAccessPool(AccessPool pool, BaseTrackers.JavaVariablePath basePathToThingThatHasThisReferenceNotChanged) {
		if(this.poolUpdater_!=null) {
			this.poolUpdater_.addToPool(pool,basePathToThingThatHasThisReferenceNotChanged);
		}
	}
	public void addPoolUpdater(DataBlockEnvironment record, BaseTrackers.JavaVariablePath pathToRecord) {
		this.poolUpdater_ = new PoolUpdater(record,pathToRecord,this.poolUpdater_);
	}
	public TargetType getBaseType() {
		return this.baseType_;
	}
	// -----------------------------------------
	 private final static class PoolUpdater {
	  	private final DataBlockEnvironment record_;
			private final JavaVariablePath pathToRecord_;
			private final PoolUpdater previous_;
			public PoolUpdater(DataBlockEnvironment record, BaseTrackers.JavaVariablePath pathToRecord, PoolUpdater previous) {
				this.record_ = record;
				this.pathToRecord_ = pathToRecord;
				this.previous_ = previous;
	  	}
			public void addToPool(AccessPool pool,BaseTrackers.JavaVariablePath basePathToThingThatHasThisReferenceNotChanged) {
				if(previous_!=null) {
					this.previous_.addToPool(pool,basePathToThingThatHasThisReferenceNotChanged);
				}
			//	Debug.println("*******************ER? NO DO THIS?!");
//				BaseTrackers.JavaVariablePath path = basePathToThingThatHasThisReferenceNotChanged.getCopy();
//				this.pathToRecord_.transferTo(path);
//				pool.addElementAccess(this.record_,path);
			}
	  }
}
