package org.ffd2.skeletonx.compile.java.layer;

import org.ffd2.skeletonx.compile.java.TargetMethod;
import org.ffd2.skeletonx.compile.java.TargetType;

public class SMethodHolder {
  private final TargetMethod method_;
  private SMethodHolder next_;
  private final TargetType targetType_;
  public SMethodHolder(TargetType targetType, TargetMethod method, SMethodHolder next) {
    this.targetType_ = targetType;
    this.method_ = method;
    this.next_ = next;
  }
  public boolean isContains(TargetType queryTargetType) {
    if(this.targetType_ == queryTargetType) {
      return true;
    } else if(next_==null) {
      return false;
    } else {
      return next_.isContains(queryTargetType);
    }
  }
  public TargetMethod getMethodQuiet(TargetType queryTargetType) {
    if(this.targetType_ == queryTargetType) {
      return this.method_;
    } else if(next_==null) {
      return null;
    } else {
      return next_.getMethodQuiet(queryTargetType);
    }
  }
}
