package org.ffd2.skeletonx.skeleton;
public final class DataBlockFormHolder {
	public static final class DataBlockFormBlock {
		private final DataBlockFormHolder.DataBlockFormBlock previous_;
		public BaseBuilder parent_;
		public DataBlockFormHolder.DataBlockFormBlock.IsRootDataBlock isRootEnd_ = null;
		public DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock isNotRootEnd_ = null;
		public DataBlockFormHolder.DataBlockFormBlock.TemplateExtensionDataBlock templateExtensionEnd_ = null;
		public DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock generalSubEnd_ = null;
		private final java.lang.String nameParameter_;
		private final IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock relatedTrackerParameter_;
		private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock targetPeerParameter_;
		private final ParameterSettingsFormHolder.ParameterSettingsFormBlock parametersParameter_;
		private org.ffd2.bones.base.BClass dataClassBonesClass_;
		private org.ffd2.bones.base.BMethod getIndexMethod_;
		private org.ffd2.bones.base.BMethod initiateTargetPeerMethod_;
		private org.ffd2.bones.base.BMethod finaliseTargetPeerMethod_;
		private org.ffd2.bones.base.BMethod setIsToOutputMethod_;
		public DataBlockFormBlock(BaseBuilder parent, java.lang.String name, IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock relatedTracker, TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock targetPeer, ParameterSettingsFormHolder.ParameterSettingsFormBlock parameters, DataBlockFormHolder.DataBlockFormBlock previous) {
			previous_ = previous;
			nameParameter_ = name;
			relatedTrackerParameter_ = relatedTracker;
			targetPeerParameter_ = targetPeer;
			parametersParameter_ = parameters;
			parent_ = parent;
		}
		public final DataBlockFormHolder.DataBlockFormBlock getPrevious() {
			return previous_;
		}
		public final BaseBuilder getRootBuilder() {
			return parent_;
		}
		public final void setPostConstruction() {
		}
		public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
			if(previous_ != null) {
				previous_.resolutionPass(packageAccess);
			}
			if(isRootEnd_ != null) {
				isRootEnd_.resolutionPass(packageAccess);
			}
			if(isNotRootEnd_ != null) {
				isNotRootEnd_.resolutionPass(packageAccess);
			}
			if(templateExtensionEnd_ != null) {
				templateExtensionEnd_.resolutionPass(packageAccess);
			}
			if(generalSubEnd_ != null) {
				generalSubEnd_.resolutionPass(packageAccess);
			}
		}
		public final void finish() {
			if(previous_ != null) {
				previous_.finish();
			}
			if(isRootEnd_ != null) {
				isRootEnd_.finish();
			}
			if(isNotRootEnd_ != null) {
				isNotRootEnd_.finish();
			}
			if(templateExtensionEnd_ != null) {
				templateExtensionEnd_.finish();
			}
			if(generalSubEnd_ != null) {
				generalSubEnd_.finish();
			}
		}
		public final BaseBuilder getParent() {
			return parent_;
		}
		public final DataBlockFormHolder.DataBlockFormBlock.IsRootDataBlock getIsRootEnd() {
			return isRootEnd_;
		}
		public final DataBlockFormHolder.DataBlockFormBlock.IsRootDataBlock addIsRoot(DesignFormHolder.DesignFormBlock design) {
			DataBlockFormHolder.DataBlockFormBlock.IsRootDataBlock child = new DataBlockFormHolder.DataBlockFormBlock.IsRootDataBlock(this, design, isRootEnd_);
			isRootEnd_ = child;
			return child;
		}
		public final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock getIsNotRootEnd() {
			return isNotRootEnd_;
		}
		public final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock addIsNotRoot(DataBlockFormHolder.DataBlockFormBlock parentDataBlock, DataBlockFormHolder.DataBlockFormBlock rootDataBlock) {
			DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock child = new DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock(this, parentDataBlock, rootDataBlock, isNotRootEnd_);
			isNotRootEnd_ = child;
			return child;
		}
		public final DataBlockFormHolder.DataBlockFormBlock.TemplateExtensionDataBlock getTemplateExtensionEnd() {
			return templateExtensionEnd_;
		}
		public final DataBlockFormHolder.DataBlockFormBlock.TemplateExtensionDataBlock addTemplateExtension(TemplateBlockFormHolder.TemplateBlockFormBlock extension) {
			DataBlockFormHolder.DataBlockFormBlock.TemplateExtensionDataBlock child = new DataBlockFormHolder.DataBlockFormBlock.TemplateExtensionDataBlock(this, extension, templateExtensionEnd_);
			templateExtensionEnd_ = child;
			return child;
		}
		public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock getGeneralSubEnd() {
			return generalSubEnd_;
		}
		public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock addGeneralSub(java.lang.String subName, DataBlockFormHolder.DataBlockFormBlock relatedDataBlock, TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.ChildRefDataBlock myRelatedChildRef, IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock subTracker, TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock subTargetPeer, ParameterSettingsFormHolder.ParameterSettingsFormBlock subSettings) {
			DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock child = new DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock(this, subName, relatedDataBlock, myRelatedChildRef, subTracker, subTargetPeer, subSettings, generalSubEnd_);
			generalSubEnd_ = child;
			return child;
		}
		public final java.lang.String getNameParameter() {
			return nameParameter_;
		}
		public final IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock getRelatedTrackerParameter() {
			return relatedTrackerParameter_;
		}
		public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock getTargetPeerParameter() {
			return targetPeerParameter_;
		}
		public final ParameterSettingsFormHolder.ParameterSettingsFormBlock getParametersParameter() {
			return parametersParameter_;
		}
		public final org.ffd2.bones.base.BClass getDataClassBonesClass() {
			return dataClassBonesClass_;
		}
		public final void setDataClassBonesClass(org.ffd2.bones.base.BClass value) {
			dataClassBonesClass_ = value;
		}
		public final org.ffd2.bones.base.BMethod getGetIndexBonesMethod() {
			return getIndexMethod_;
		}
		public final void setGetIndexBonesMethod(org.ffd2.bones.base.BMethod value) {
			getIndexMethod_ = value;
		}
		public final org.ffd2.bones.base.BMethod getInitiateTargetPeerBonesMethod() {
			return initiateTargetPeerMethod_;
		}
		public final void setInitiateTargetPeerBonesMethod(org.ffd2.bones.base.BMethod value) {
			initiateTargetPeerMethod_ = value;
		}
		public final org.ffd2.bones.base.BMethod getFinaliseTargetPeerBonesMethod() {
			return finaliseTargetPeerMethod_;
		}
		public final void setFinaliseTargetPeerBonesMethod(org.ffd2.bones.base.BMethod value) {
			finaliseTargetPeerMethod_ = value;
		}
		public final org.ffd2.bones.base.BMethod getSetIsToOutputBonesMethod() {
			return setIsToOutputMethod_;
		}
		public final void setSetIsToOutputBonesMethod(org.ffd2.bones.base.BMethod value) {
			setIsToOutputMethod_ = value;
		}
		public static final class IsRootDataBlock {
			private final DataBlockFormHolder.DataBlockFormBlock.IsRootDataBlock previous_;
			public DataBlockFormHolder.DataBlockFormBlock parent_;
			private final DesignFormHolder.DesignFormBlock designParameter_;
			public IsRootDataBlock(DataBlockFormHolder.DataBlockFormBlock parent, DesignFormHolder.DesignFormBlock design, DataBlockFormHolder.DataBlockFormBlock.IsRootDataBlock previous) {
				previous_ = previous;
				designParameter_ = design;
				parent_ = parent;
			}
			public final DataBlockFormHolder.DataBlockFormBlock.IsRootDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
			}
			public final DataBlockFormHolder.DataBlockFormBlock getParent() {
				return parent_;
			}
			public final DesignFormHolder.DesignFormBlock getDesignParameter() {
				return designParameter_;
			}
		}
		public static final class IsNotRootDataBlock {
			private final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock previous_;
			private org.ffd2.bones.base.ChainLink blockParentLink_;
			public DataBlockFormHolder.DataBlockFormBlock parent_;
			public DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsRootDataBlock parentIsRootEnd_ = null;
			public DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsNotRootDataBlock parentIsNotRootEnd_ = null;
			private final DataBlockFormHolder.DataBlockFormBlock parentDataBlockParameter_;
			private final DataBlockFormHolder.DataBlockFormBlock rootDataBlockParameter_;
			private org.ffd2.bones.base.BMethod getParentMethod_;
			private org.ffd2.bones.base.BMethod getRootMethod_;
			public IsNotRootDataBlock(DataBlockFormHolder.DataBlockFormBlock parent, DataBlockFormHolder.DataBlockFormBlock parentDataBlock, DataBlockFormHolder.DataBlockFormBlock rootDataBlock, DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock previous) {
				previous_ = previous;
				parentDataBlockParameter_ = parentDataBlock;
				rootDataBlockParameter_ = rootDataBlock;
				parent_ = parent;
			}
			public final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				if(parentIsRootEnd_ != null) {
					parentIsRootEnd_.resolutionPass(packageAccess);
				}
				if(parentIsNotRootEnd_ != null) {
					parentIsNotRootEnd_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				if(parentIsRootEnd_ != null) {
					parentIsRootEnd_.finish();
				}
				if(parentIsNotRootEnd_ != null) {
					parentIsNotRootEnd_.finish();
				}
			}
			public final void setConnection(org.ffd2.bones.base.ChainLink link) {
				blockParentLink_ = link;
			}
			public final void addBlockParentConnection(org.ffd2.bones.base.CallChain chain) {
				chain.chainLink(blockParentLink_);
			}
			public final DataBlockFormHolder.DataBlockFormBlock getParent() {
				return parent_;
			}
			public final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsRootDataBlock getParentIsRootEnd() {
				return parentIsRootEnd_;
			}
			public final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsRootDataBlock addParentIsRoot() {
				DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsRootDataBlock child = new DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsRootDataBlock(this, parentIsRootEnd_);
				parentIsRootEnd_ = child;
				return child;
			}
			public final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsNotRootDataBlock getParentIsNotRootEnd() {
				return parentIsNotRootEnd_;
			}
			public final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsNotRootDataBlock addParentIsNotRoot(DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock parentSpecificsDataBlock) {
				DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsNotRootDataBlock child = new DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsNotRootDataBlock(this, parentSpecificsDataBlock, parentIsNotRootEnd_);
				parentIsNotRootEnd_ = child;
				return child;
			}
			public final DataBlockFormHolder.DataBlockFormBlock getParentDataBlockParameter() {
				return parentDataBlockParameter_;
			}
			public final DataBlockFormHolder.DataBlockFormBlock getRootDataBlockParameter() {
				return rootDataBlockParameter_;
			}
			public final org.ffd2.bones.base.BMethod getGetParentBonesMethod() {
				return getParentMethod_;
			}
			public final void setGetParentBonesMethod(org.ffd2.bones.base.BMethod value) {
				getParentMethod_ = value;
			}
			public final org.ffd2.bones.base.BMethod getGetRootBonesMethod() {
				return getRootMethod_;
			}
			public final void setGetRootBonesMethod(org.ffd2.bones.base.BMethod value) {
				getRootMethod_ = value;
			}
			public static final class ParentIsRootDataBlock {
				private final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsRootDataBlock previous_;
				public DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock parent_;
				public ParentIsRootDataBlock(DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock parent, DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsRootDataBlock previous) {
					previous_ = previous;
					parent_ = parent;
				}
				public final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsRootDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock getParent() {
					return parent_;
				}
			}
			public static final class ParentIsNotRootDataBlock {
				private final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsNotRootDataBlock previous_;
				public DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock parent_;
				private final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock parentSpecificsDataBlockParameter_;
				public ParentIsNotRootDataBlock(DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock parent, DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock parentSpecificsDataBlock, DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsNotRootDataBlock previous) {
					previous_ = previous;
					parentSpecificsDataBlockParameter_ = parentSpecificsDataBlock;
					parent_ = parent;
				}
				public final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock.ParentIsNotRootDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock getParent() {
					return parent_;
				}
				public final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock getParentSpecificsDataBlockParameter() {
					return parentSpecificsDataBlockParameter_;
				}
			}
		}
		public static final class TemplateExtensionDataBlock {
			private final DataBlockFormHolder.DataBlockFormBlock.TemplateExtensionDataBlock previous_;
			public DataBlockFormHolder.DataBlockFormBlock parent_;
			private final TemplateBlockFormHolder.TemplateBlockFormBlock extensionParameter_;
			public TemplateExtensionDataBlock(DataBlockFormHolder.DataBlockFormBlock parent, TemplateBlockFormHolder.TemplateBlockFormBlock extension, DataBlockFormHolder.DataBlockFormBlock.TemplateExtensionDataBlock previous) {
				previous_ = previous;
				extensionParameter_ = extension;
				parent_ = parent;
			}
			public final DataBlockFormHolder.DataBlockFormBlock.TemplateExtensionDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
			}
			public final DataBlockFormHolder.DataBlockFormBlock getParent() {
				return parent_;
			}
			public final TemplateBlockFormHolder.TemplateBlockFormBlock getExtensionParameter() {
				return extensionParameter_;
			}
		}
		public static final class GeneralSubDataBlock {
			private final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock previous_;
			public DataBlockFormHolder.DataBlockFormBlock parent_;
			public DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsDependentDataBlock isDependentEnd_ = null;
			public DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsMaybeDataBlock isMaybeEnd_ = null;
			public DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock multiEnd_ = null;
			private final java.lang.String subNameParameter_;
			private final DataBlockFormHolder.DataBlockFormBlock relatedDataBlockParameter_;
			private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.ChildRefDataBlock myRelatedChildRefParameter_;
			private final IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock subTrackerParameter_;
			private final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock subTargetPeerParameter_;
			private final ParameterSettingsFormHolder.ParameterSettingsFormBlock subSettingsParameter_;
			public GeneralSubDataBlock(DataBlockFormHolder.DataBlockFormBlock parent, java.lang.String subName, DataBlockFormHolder.DataBlockFormBlock relatedDataBlock, TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.ChildRefDataBlock myRelatedChildRef, IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock subTracker, TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock subTargetPeer, ParameterSettingsFormHolder.ParameterSettingsFormBlock subSettings, DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock previous) {
				previous_ = previous;
				subNameParameter_ = subName;
				relatedDataBlockParameter_ = relatedDataBlock;
				myRelatedChildRefParameter_ = myRelatedChildRef;
				subTrackerParameter_ = subTracker;
				subTargetPeerParameter_ = subTargetPeer;
				subSettingsParameter_ = subSettings;
				parent_ = parent;
			}
			public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				if(isDependentEnd_ != null) {
					isDependentEnd_.resolutionPass(packageAccess);
				}
				if(isMaybeEnd_ != null) {
					isMaybeEnd_.resolutionPass(packageAccess);
				}
				if(multiEnd_ != null) {
					multiEnd_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				if(isDependentEnd_ != null) {
					isDependentEnd_.finish();
				}
				if(isMaybeEnd_ != null) {
					isMaybeEnd_.finish();
				}
				if(multiEnd_ != null) {
					multiEnd_.finish();
				}
			}
			public final DataBlockFormHolder.DataBlockFormBlock getParent() {
				return parent_;
			}
			public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsDependentDataBlock getIsDependentEnd() {
				return isDependentEnd_;
			}
			public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsDependentDataBlock addIsDependent() {
				DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsDependentDataBlock child = new DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsDependentDataBlock(this, isDependentEnd_);
				isDependentEnd_ = child;
				return child;
			}
			public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsMaybeDataBlock getIsMaybeEnd() {
				return isMaybeEnd_;
			}
			public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsMaybeDataBlock addIsMaybe() {
				DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsMaybeDataBlock child = new DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsMaybeDataBlock(this, isMaybeEnd_);
				isMaybeEnd_ = child;
				return child;
			}
			public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock getMultiEnd() {
				return multiEnd_;
			}
			public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock addMulti() {
				DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock child = new DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock(this, multiEnd_);
				multiEnd_ = child;
				return child;
			}
			public final java.lang.String getSubNameParameter() {
				return subNameParameter_;
			}
			public final DataBlockFormHolder.DataBlockFormBlock getRelatedDataBlockParameter() {
				return relatedDataBlockParameter_;
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock.ChildRefDataBlock getMyRelatedChildRefParameter() {
				return myRelatedChildRefParameter_;
			}
			public final IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock getSubTrackerParameter() {
				return subTrackerParameter_;
			}
			public final TargetBaseFormHolder.TargetBaseFormBlock.BlockDataBlock getSubTargetPeerParameter() {
				return subTargetPeerParameter_;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock getSubSettingsParameter() {
				return subSettingsParameter_;
			}
			public static final class IsDependentDataBlock {
				private final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsDependentDataBlock previous_;
				public DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock parent_;
				public IsDependentDataBlock(DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock parent, DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsDependentDataBlock previous) {
					previous_ = previous;
					parent_ = parent;
				}
				public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsDependentDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock getParent() {
					return parent_;
				}
			}
			public static final class IsMaybeDataBlock {
				private final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsMaybeDataBlock previous_;
				public DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock parent_;
				public IsMaybeDataBlock(DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock parent, DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsMaybeDataBlock previous) {
					previous_ = previous;
					parent_ = parent;
				}
				public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.IsMaybeDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock getParent() {
					return parent_;
				}
			}
			public static final class MultiDataBlock {
				private final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock previous_;
				public DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock parent_;
				public DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsZeroOrMoreDataBlock isZeroOrMoreEnd_ = null;
				public DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsOneOrMoreDataBlock isOneOrMoreEnd_ = null;
				public MultiDataBlock(DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock parent, DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock previous) {
					previous_ = previous;
					parent_ = parent;
				}
				public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
					if(isZeroOrMoreEnd_ != null) {
						isZeroOrMoreEnd_.resolutionPass(packageAccess);
					}
					if(isOneOrMoreEnd_ != null) {
						isOneOrMoreEnd_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					if(isZeroOrMoreEnd_ != null) {
						isZeroOrMoreEnd_.finish();
					}
					if(isOneOrMoreEnd_ != null) {
						isOneOrMoreEnd_.finish();
					}
				}
				public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock getParent() {
					return parent_;
				}
				public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsZeroOrMoreDataBlock getIsZeroOrMoreEnd() {
					return isZeroOrMoreEnd_;
				}
				public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsZeroOrMoreDataBlock addIsZeroOrMore() {
					DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsZeroOrMoreDataBlock child = new DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsZeroOrMoreDataBlock(this, isZeroOrMoreEnd_);
					isZeroOrMoreEnd_ = child;
					return child;
				}
				public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsOneOrMoreDataBlock getIsOneOrMoreEnd() {
					return isOneOrMoreEnd_;
				}
				public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsOneOrMoreDataBlock addIsOneOrMore() {
					DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsOneOrMoreDataBlock child = new DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsOneOrMoreDataBlock(this, isOneOrMoreEnd_);
					isOneOrMoreEnd_ = child;
					return child;
				}
				public static final class IsZeroOrMoreDataBlock {
					private final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsZeroOrMoreDataBlock previous_;
					public DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock parent_;
					public IsZeroOrMoreDataBlock(DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock parent, DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsZeroOrMoreDataBlock previous) {
						previous_ = previous;
						parent_ = parent;
					}
					public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsZeroOrMoreDataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
					}
					public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock getParent() {
						return parent_;
					}
				}
				public static final class IsOneOrMoreDataBlock {
					private final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsOneOrMoreDataBlock previous_;
					public DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock parent_;
					public IsOneOrMoreDataBlock(DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock parent, DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsOneOrMoreDataBlock previous) {
						previous_ = previous;
						parent_ = parent;
					}
					public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock.IsOneOrMoreDataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
					}
					public final DataBlockFormHolder.DataBlockFormBlock.GeneralSubDataBlock.MultiDataBlock getParent() {
						return parent_;
					}
				}
			}
		}
	}
}
