package org.ffd2.skeletonx.skeleton;
public final class IDTrackerFormHolder {
	public static final class IDTrackerFormBlock {
		private final IDTrackerFormHolder.IDTrackerFormBlock previous_;
		public BaseBuilder parent_;
		public IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock typeEnd_ = null;
		public IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock chainEnd_ = null;
		private final java.lang.String nameParameter_;
		private org.ffd2.bones.base.BClass iDTrackerBonesClass_;
		private final org.ffd2.bones.base.BCodeBlock constructorCode_;
		private final org.ffd2.bones.base.BCodeBlock constructorCode__1_;
		private final org.ffd2.bones.base.BCodeBlock mooCode_;
		private org.ffd2.bones.base.BMethod mooMethod_;
		private final org.ffd2.bones.base.BConstructor bonesConstructor_;
		public IDTrackerFormBlock(BaseBuilder parent, java.lang.String name, IDTrackerFormHolder.IDTrackerFormBlock previous) {
			previous_ = previous;
			nameParameter_ = name;
			parent_ = parent;
			iDTrackerBonesClass_ = new org.ffd2.bones.base.BClass(true);
			constructorCode_ = new org.ffd2.bones.base.BCodeBlock();
			constructorCode__1_ = new org.ffd2.bones.base.BCodeBlock();
			mooCode_ = new org.ffd2.bones.base.BCodeBlock();
			mooMethod_ = new org.ffd2.bones.base.BMethod();
			mooMethod_.setCodeBlock(getMooCode());
			bonesConstructor_ = new org.ffd2.bones.base.BConstructor();
			bonesConstructor_.setCodeBlock(getConstructorCode());
			bonesConstructor_.setPublic();
		}
		public final IDTrackerFormHolder.IDTrackerFormBlock getPrevious() {
			return previous_;
		}
		public final BaseBuilder getRootBuilder() {
			return parent_;
		}
		public final void setPostConstruction() {
		}
		public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
			if(previous_ != null) {
				previous_.resolutionPass(packageAccess);
			}
			packageAccess.addType(iDTrackerBonesClass_);
			iDTrackerBonesClass_.setName(this.getNameParameter(), "IDTracker");
			this.getIDTrackerBonesClass().addInstanceMethod(mooMethod_);
			org.ffd2.bones.base.BParameters parameters = mooMethod_.getParameters();
			this.getIDTrackerBonesClass().addConstructor(bonesConstructor_);
			org.ffd2.bones.base.BParameters parameters_1 = bonesConstructor_.getParameters();
			if(typeEnd_ != null) {
				typeEnd_.resolutionPass(packageAccess);
			}
			if(chainEnd_ != null) {
				chainEnd_.resolutionPass(packageAccess);
			}
		}
		public final void finish() {
			if(previous_ != null) {
				previous_.finish();
			}
			mooMethod_.setName("moo");
			org.ffd2.bones.base.TypeSettable returnType = mooMethod_.getReturnTypeSettable();
			returnType.setIntResultType();
			org.ffd2.bones.base.BCodeBlock target = getMooCode();
			org.ffd2.bones.base.BExpression returnValue = new org.ffd2.bones.base.BExpression();
			returnValue.primitiveInt(4);
			target.addReturn(returnValue);
			org.ffd2.bones.base.BCodeBlock target_1 = getConstructorCode();
			target_1.insertCode(getConstructorCode_1());
			if(typeEnd_ != null) {
				typeEnd_.finish();
			}
			if(chainEnd_ != null) {
				chainEnd_.finish();
			}
		}
		public final BaseBuilder getParent() {
			return parent_;
		}
		public final IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock getTypeEnd() {
			return typeEnd_;
		}
		public final IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock addType(java.lang.String name, int id) {
			IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock child = new IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock(this, name, id, typeEnd_);
			typeEnd_ = child;
			return child;
		}
		public final IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock getChainEnd() {
			return chainEnd_;
		}
		public final IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock addChain(java.lang.String name, int id) {
			IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock child = new IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock(this, name, id, chainEnd_);
			chainEnd_ = child;
			return child;
		}
		public final java.lang.String getNameParameter() {
			return nameParameter_;
		}
		public final org.ffd2.bones.base.BClass getIDTrackerBonesClass() {
			return iDTrackerBonesClass_;
		}
		public final org.ffd2.bones.base.BCodeBlock getConstructorCode() {
			return constructorCode_;
		}
		public final org.ffd2.bones.base.BCodeBlock getConstructorCode_1() {
			return constructorCode__1_;
		}
		public final org.ffd2.bones.base.BCodeBlock getMooCode() {
			return mooCode_;
		}
		public final org.ffd2.bones.base.BMethod getMooBonesMethod() {
			return mooMethod_;
		}
		public static final class TypeDataBlock {
			private final IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock previous_;
			public IDTrackerFormHolder.IDTrackerFormBlock parent_;
			private final java.lang.String nameParameter_;
			private final int idParameter_;
			private org.ffd2.bones.base.InstanceVariable count_Bones_;
			private final org.ffd2.bones.base.BCodeBlock newIndexCode_;
			private org.ffd2.bones.base.BMethod newIndexMethod_;
			public TypeDataBlock(IDTrackerFormHolder.IDTrackerFormBlock parent, java.lang.String name, int id, IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock previous) {
				previous_ = previous;
				nameParameter_ = name;
				idParameter_ = id;
				parent_ = parent;
				count_Bones_ = new org.ffd2.bones.base.InstanceVariable();
				newIndexCode_ = new org.ffd2.bones.base.BCodeBlock();
				newIndexMethod_ = new org.ffd2.bones.base.BMethod();
				newIndexMethod_.setCodeBlock(getNewIndexCode());
			}
			public final IDTrackerFormHolder.IDTrackerFormBlock.TypeDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				getParent().getIDTrackerBonesClass().addInstanceVariable(count_Bones_);
				count_Bones_.setName(this.getNameParameter(), java.lang.String.valueOf(this.getIdParameter()), "BlockCount_");
				getParent().getIDTrackerBonesClass().addInstanceMethod(newIndexMethod_);
				org.ffd2.bones.base.BParameters parameters = newIndexMethod_.getParameters();
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				newIndexMethod_.setName(this.getNameParameter(), java.lang.String.valueOf(this.getIdParameter()), "newBlockID");
				org.ffd2.bones.base.TypeSettable returnType = newIndexMethod_.getReturnTypeSettable();
				returnType.setIntResultType();
				org.ffd2.bones.base.TypeSettable varableType = count_Bones_.getTypeSettable();
				varableType.setIntResultType();
				org.ffd2.bones.base.BCodeBlock target = getNewIndexCode();
				org.ffd2.bones.base.BExpression returnValue = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.BExpression unary = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.BExpression unary_1 = new org.ffd2.bones.base.BExpression();
				unary_1.variable(this.getCount_BonesVariable());
				unary.postUnary(unary_1, "+");
				returnValue.postUnary(unary, "+");
				target.addReturn(returnValue);
				org.ffd2.bones.base.BCodeBlock localCode = getParent().getConstructorCode_1().anchor();
				org.ffd2.bones.base.BExpression expressionValue = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.BExpression right = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.BExpression left = new org.ffd2.bones.base.BExpression();
				left.variable(this.getCount_BonesVariable());
				right.primitiveInt(0);
				expressionValue.binary(left, "=", right);
				localCode.addExpression(expressionValue);
			}
			public final IDTrackerFormHolder.IDTrackerFormBlock getParent() {
				return parent_;
			}
			public final java.lang.String getNameParameter() {
				return nameParameter_;
			}
			public final int getIdParameter() {
				return idParameter_;
			}
			public final org.ffd2.bones.base.InstanceVariable getCount_BonesVariable() {
				return count_Bones_;
			}
			public final org.ffd2.bones.base.BCodeBlock getNewIndexCode() {
				return newIndexCode_;
			}
			public final org.ffd2.bones.base.BMethod getNewIndexBonesMethod() {
				return newIndexMethod_;
			}
		}
		public static final class ChainDataBlock {
			private final IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock previous_;
			public IDTrackerFormHolder.IDTrackerFormBlock parent_;
			private final java.lang.String nameParameter_;
			private final int idParameter_;
			private org.ffd2.bones.base.InstanceVariable count_Bones_;
			private final org.ffd2.bones.base.BCodeBlock newIndexCode_;
			private final org.ffd2.bones.base.BCodeBlock getChainCountCode_;
			private org.ffd2.bones.base.BMethod newIndexMethod_;
			private org.ffd2.bones.base.BMethod getChainCountMethod_;
			public ChainDataBlock(IDTrackerFormHolder.IDTrackerFormBlock parent, java.lang.String name, int id, IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock previous) {
				previous_ = previous;
				nameParameter_ = name;
				idParameter_ = id;
				parent_ = parent;
				count_Bones_ = new org.ffd2.bones.base.InstanceVariable();
				newIndexCode_ = new org.ffd2.bones.base.BCodeBlock();
				getChainCountCode_ = new org.ffd2.bones.base.BCodeBlock();
				newIndexMethod_ = new org.ffd2.bones.base.BMethod();
				newIndexMethod_.setCodeBlock(getNewIndexCode());
				getChainCountMethod_ = new org.ffd2.bones.base.BMethod();
				getChainCountMethod_.setCodeBlock(getGetChainCountCode());
			}
			public final IDTrackerFormHolder.IDTrackerFormBlock.ChainDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				getParent().getIDTrackerBonesClass().addInstanceVariable(count_Bones_);
				count_Bones_.setName(this.getNameParameter(), java.lang.String.valueOf(this.getIdParameter()), "ChainCount_");
				getParent().getIDTrackerBonesClass().addInstanceMethod(newIndexMethod_);
				org.ffd2.bones.base.BParameters parameters = newIndexMethod_.getParameters();
				getParent().getIDTrackerBonesClass().addInstanceMethod(getChainCountMethod_);
				org.ffd2.bones.base.BParameters parameters_1 = getChainCountMethod_.getParameters();
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				newIndexMethod_.setName(this.getNameParameter(), java.lang.String.valueOf(this.getIdParameter()), "newChainID");
				org.ffd2.bones.base.TypeSettable returnType = newIndexMethod_.getReturnTypeSettable();
				returnType.setIntResultType();
				getChainCountMethod_.setName("get", this.getNameParameter(), java.lang.String.valueOf(this.getIdParameter()), "ChainCount");
				org.ffd2.bones.base.TypeSettable returnType_1 = getChainCountMethod_.getReturnTypeSettable();
				returnType_1.setIntResultType();
				org.ffd2.bones.base.TypeSettable varableType = count_Bones_.getTypeSettable();
				varableType.setIntResultType();
				org.ffd2.bones.base.BCodeBlock target = getNewIndexCode();
				org.ffd2.bones.base.BExpression returnValue = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.BExpression unary = new org.ffd2.bones.base.BExpression();
				org.ffd2.bones.base.BExpression unary_1 = new org.ffd2.bones.base.BExpression();
				unary_1.variable(this.getCount_BonesVariable());
				unary.postUnary(unary_1, "+");
				returnValue.postUnary(unary, "+");
				target.addReturn(returnValue);
				org.ffd2.bones.base.BCodeBlock target_1 = getGetChainCountCode();
				org.ffd2.bones.base.BExpression returnValue_1 = new org.ffd2.bones.base.BExpression();
				returnValue_1.variable(this.getCount_BonesVariable());
				target_1.addReturn(returnValue_1);
			}
			public final IDTrackerFormHolder.IDTrackerFormBlock getParent() {
				return parent_;
			}
			public final java.lang.String getNameParameter() {
				return nameParameter_;
			}
			public final int getIdParameter() {
				return idParameter_;
			}
			public final org.ffd2.bones.base.InstanceVariable getCount_BonesVariable() {
				return count_Bones_;
			}
			public final org.ffd2.bones.base.BCodeBlock getNewIndexCode() {
				return newIndexCode_;
			}
			public final org.ffd2.bones.base.BCodeBlock getGetChainCountCode() {
				return getChainCountCode_;
			}
			public final org.ffd2.bones.base.BMethod getNewIndexBonesMethod() {
				return newIndexMethod_;
			}
			public final org.ffd2.bones.base.BMethod getGetChainCountBonesMethod() {
				return getChainCountMethod_;
			}
		}
	}
}
