package org.ffd2.skeletonx.skeleton;
public final class KeyBuilderFormHolder {
	public static final class KeyBuilderFormBlock {
		private final KeyBuilderFormHolder.KeyBuilderFormBlock previous_;
		public BaseBuilder parent_;
		private final java.lang.String keyNameParameter_;
		private org.ffd2.bones.base.BClass keyMarkerInterfaceBonesClass_;
		public KeyBuilderFormBlock(BaseBuilder parent, java.lang.String keyName, KeyBuilderFormHolder.KeyBuilderFormBlock previous) {
			previous_ = previous;
			keyNameParameter_ = keyName;
			parent_ = parent;
			keyMarkerInterfaceBonesClass_ = new org.ffd2.bones.base.BClass(false);
		}
		public final KeyBuilderFormHolder.KeyBuilderFormBlock getPrevious() {
			return previous_;
		}
		public final BaseBuilder getRootBuilder() {
			return parent_;
		}
		public final void setPostConstruction() {
		}
		public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
			if(previous_ != null) {
				previous_.resolutionPass(packageAccess);
			}
			packageAccess.addType(keyMarkerInterfaceBonesClass_);
			keyMarkerInterfaceBonesClass_.setName(this.getKeyNameParameter(), "KeyMarkerInterface");
		}
		public final void finish() {
			if(previous_ != null) {
				previous_.finish();
			}
		}
		public final BaseBuilder getParent() {
			return parent_;
		}
		public final java.lang.String getKeyNameParameter() {
			return keyNameParameter_;
		}
		public final org.ffd2.bones.base.BClass getKeyMarkerInterfaceBonesClass() {
			return keyMarkerInterfaceBonesClass_;
		}
	}
}
