package org.ffd2.skeletonx.skeleton;
public final class NameDetailsFormHolder {
	public static final class NameDetailsFormBlock {
		private final NameDetailsFormHolder.NameDetailsFormBlock previous_;
		public BaseBuilder parent_;
		public NameDetailsFormHolder.NameDetailsFormBlock.SimpleDataBlock simpleEnd_ = null;
		public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock complexEnd_ = null;
		public NameDetailsFormBlock(BaseBuilder parent, NameDetailsFormHolder.NameDetailsFormBlock previous) {
			previous_ = previous;
			parent_ = parent;
		}
		public final NameDetailsFormHolder.NameDetailsFormBlock getPrevious() {
			return previous_;
		}
		public final BaseBuilder getRootBuilder() {
			return parent_;
		}
		public final void setPostConstruction() {
		}
		public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
			if(previous_ != null) {
				previous_.resolutionPass(packageAccess);
			}
			if(simpleEnd_ != null) {
				simpleEnd_.resolutionPass(packageAccess);
			}
			if(complexEnd_ != null) {
				complexEnd_.resolutionPass(packageAccess);
			}
		}
		public final void finish() {
			if(previous_ != null) {
				previous_.finish();
			}
			if(simpleEnd_ != null) {
				simpleEnd_.finish();
			}
			if(complexEnd_ != null) {
				complexEnd_.finish();
			}
		}
		public final BaseBuilder getParent() {
			return parent_;
		}
		public final NameDetailsFormHolder.NameDetailsFormBlock.SimpleDataBlock getSimpleEnd() {
			return simpleEnd_;
		}
		public final NameDetailsFormHolder.NameDetailsFormBlock.SimpleDataBlock addSimple(java.lang.String simpleValue) {
			NameDetailsFormHolder.NameDetailsFormBlock.SimpleDataBlock child = new NameDetailsFormHolder.NameDetailsFormBlock.SimpleDataBlock(this, simpleValue, simpleEnd_);
			simpleEnd_ = child;
			return child;
		}
		public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock getComplexEnd() {
			return complexEnd_;
		}
		public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock addComplex() {
			NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock child = new NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock(this, complexEnd_);
			complexEnd_ = child;
			return child;
		}
		public static final class SimpleDataBlock {
			private final NameDetailsFormHolder.NameDetailsFormBlock.SimpleDataBlock previous_;
			public NameDetailsFormHolder.NameDetailsFormBlock parent_;
			private final java.lang.String simpleValueParameter_;
			public SimpleDataBlock(NameDetailsFormHolder.NameDetailsFormBlock parent, java.lang.String simpleValue, NameDetailsFormHolder.NameDetailsFormBlock.SimpleDataBlock previous) {
				previous_ = previous;
				simpleValueParameter_ = simpleValue;
				parent_ = parent;
			}
			public final NameDetailsFormHolder.NameDetailsFormBlock.SimpleDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
			}
			public final NameDetailsFormHolder.NameDetailsFormBlock getParent() {
				return parent_;
			}
			public final java.lang.String getSimpleValueParameter() {
				return simpleValueParameter_;
			}
		}
		public static final class ComplexDataBlock {
			private final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock previous_;
			public NameDetailsFormHolder.NameDetailsFormBlock parent_;
			public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock nameElementEnd_ = null;
			public ComplexDataBlock(NameDetailsFormHolder.NameDetailsFormBlock parent, NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock previous) {
				previous_ = previous;
				parent_ = parent;
			}
			public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				if(nameElementEnd_ != null) {
					nameElementEnd_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				if(nameElementEnd_ != null) {
					nameElementEnd_.finish();
				}
			}
			public final NameDetailsFormHolder.NameDetailsFormBlock getParent() {
				return parent_;
			}
			public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock getNameElementEnd() {
				return nameElementEnd_;
			}
			public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock addNameElement() {
				NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock child = new NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock(this, nameElementEnd_);
				nameElementEnd_ = child;
				return child;
			}
			public static final class NameElementDataBlock {
				private final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock previous_;
				public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock parent_;
				public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDataBlock stringEnd_ = null;
				public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringParameterDataBlock stringParameterEnd_ = null;
				public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringCapitalisedParameterDataBlock stringCapitalisedParameterEnd_ = null;
				public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDecapitalisedParameterDataBlock stringDecapitalisedParameterEnd_ = null;
				public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.DoubleParameterDataBlock doubleParameterEnd_ = null;
				public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.IntParameterDataBlock intParameterEnd_ = null;
				public NameElementDataBlock(NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock parent, NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock previous) {
					previous_ = previous;
					parent_ = parent;
				}
				public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
					if(stringEnd_ != null) {
						stringEnd_.resolutionPass(packageAccess);
					}
					if(stringParameterEnd_ != null) {
						stringParameterEnd_.resolutionPass(packageAccess);
					}
					if(stringCapitalisedParameterEnd_ != null) {
						stringCapitalisedParameterEnd_.resolutionPass(packageAccess);
					}
					if(stringDecapitalisedParameterEnd_ != null) {
						stringDecapitalisedParameterEnd_.resolutionPass(packageAccess);
					}
					if(doubleParameterEnd_ != null) {
						doubleParameterEnd_.resolutionPass(packageAccess);
					}
					if(intParameterEnd_ != null) {
						intParameterEnd_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					if(stringEnd_ != null) {
						stringEnd_.finish();
					}
					if(stringParameterEnd_ != null) {
						stringParameterEnd_.finish();
					}
					if(stringCapitalisedParameterEnd_ != null) {
						stringCapitalisedParameterEnd_.finish();
					}
					if(stringDecapitalisedParameterEnd_ != null) {
						stringDecapitalisedParameterEnd_.finish();
					}
					if(doubleParameterEnd_ != null) {
						doubleParameterEnd_.finish();
					}
					if(intParameterEnd_ != null) {
						intParameterEnd_.finish();
					}
				}
				public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock getParent() {
					return parent_;
				}
				public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDataBlock getStringEnd() {
					return stringEnd_;
				}
				public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDataBlock addString(java.lang.String value) {
					NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDataBlock child = new NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDataBlock(this, value, stringEnd_);
					stringEnd_ = child;
					return child;
				}
				public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringParameterDataBlock getStringParameterEnd() {
					return stringParameterEnd_;
				}
				public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringParameterDataBlock addStringParameter(BaseTrackers.JavaVariablePath variablePath, StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock targetParameter) {
					NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringParameterDataBlock child = new NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringParameterDataBlock(this, variablePath, targetParameter, stringParameterEnd_);
					stringParameterEnd_ = child;
					return child;
				}
				public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringCapitalisedParameterDataBlock getStringCapitalisedParameterEnd() {
					return stringCapitalisedParameterEnd_;
				}
				public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringCapitalisedParameterDataBlock addStringCapitalisedParameter(BaseTrackers.JavaVariablePath variablePath, StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock targetParameter) {
					NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringCapitalisedParameterDataBlock child = new NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringCapitalisedParameterDataBlock(this, variablePath, targetParameter, stringCapitalisedParameterEnd_);
					stringCapitalisedParameterEnd_ = child;
					return child;
				}
				public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDecapitalisedParameterDataBlock getStringDecapitalisedParameterEnd() {
					return stringDecapitalisedParameterEnd_;
				}
				public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDecapitalisedParameterDataBlock addStringDecapitalisedParameter(BaseTrackers.JavaVariablePath variablePath, StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock targetParameter) {
					NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDecapitalisedParameterDataBlock child = new NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDecapitalisedParameterDataBlock(this, variablePath, targetParameter, stringDecapitalisedParameterEnd_);
					stringDecapitalisedParameterEnd_ = child;
					return child;
				}
				public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.DoubleParameterDataBlock getDoubleParameterEnd() {
					return doubleParameterEnd_;
				}
				public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.DoubleParameterDataBlock addDoubleParameter(BaseTrackers.JavaVariablePath variablePath, DoubleBuilderVariableAccessFormHolder.DoubleBuilderVariableAccessFormBlock targetParameter) {
					NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.DoubleParameterDataBlock child = new NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.DoubleParameterDataBlock(this, variablePath, targetParameter, doubleParameterEnd_);
					doubleParameterEnd_ = child;
					return child;
				}
				public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.IntParameterDataBlock getIntParameterEnd() {
					return intParameterEnd_;
				}
				public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.IntParameterDataBlock addIntParameter(BaseTrackers.JavaVariablePath variablePath, IntBuilderVariableAccessFormHolder.IntBuilderVariableAccessFormBlock targetParameter) {
					NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.IntParameterDataBlock child = new NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.IntParameterDataBlock(this, variablePath, targetParameter, intParameterEnd_);
					intParameterEnd_ = child;
					return child;
				}
				public static final class StringDataBlock {
					private final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDataBlock previous_;
					public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock parent_;
					private final java.lang.String valueParameter_;
					public StringDataBlock(NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock parent, java.lang.String value, NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDataBlock previous) {
						previous_ = previous;
						valueParameter_ = value;
						parent_ = parent;
					}
					public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
					}
					public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock getParent() {
						return parent_;
					}
					public final java.lang.String getValueParameter() {
						return valueParameter_;
					}
				}
				public static final class StringParameterDataBlock {
					private final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringParameterDataBlock previous_;
					public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock parent_;
					private final BaseTrackers.JavaVariablePath variablePathParameter_;
					private final StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock targetParameterParameter_;
					public StringParameterDataBlock(NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock parent, BaseTrackers.JavaVariablePath variablePath, StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock targetParameter, NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringParameterDataBlock previous) {
						previous_ = previous;
						variablePathParameter_ = variablePath;
						targetParameterParameter_ = targetParameter;
						parent_ = parent;
					}
					public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringParameterDataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
					}
					public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock getParent() {
						return parent_;
					}
					public final BaseTrackers.JavaVariablePath getVariablePathParameter() {
						return variablePathParameter_;
					}
					public final StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock getTargetParameterParameter() {
						return targetParameterParameter_;
					}
				}
				public static final class StringCapitalisedParameterDataBlock {
					private final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringCapitalisedParameterDataBlock previous_;
					public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock parent_;
					private final BaseTrackers.JavaVariablePath variablePathParameter_;
					private final StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock targetParameterParameter_;
					public StringCapitalisedParameterDataBlock(NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock parent, BaseTrackers.JavaVariablePath variablePath, StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock targetParameter, NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringCapitalisedParameterDataBlock previous) {
						previous_ = previous;
						variablePathParameter_ = variablePath;
						targetParameterParameter_ = targetParameter;
						parent_ = parent;
					}
					public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringCapitalisedParameterDataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
					}
					public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock getParent() {
						return parent_;
					}
					public final BaseTrackers.JavaVariablePath getVariablePathParameter() {
						return variablePathParameter_;
					}
					public final StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock getTargetParameterParameter() {
						return targetParameterParameter_;
					}
				}
				public static final class StringDecapitalisedParameterDataBlock {
					private final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDecapitalisedParameterDataBlock previous_;
					public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock parent_;
					private final BaseTrackers.JavaVariablePath variablePathParameter_;
					private final StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock targetParameterParameter_;
					public StringDecapitalisedParameterDataBlock(NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock parent, BaseTrackers.JavaVariablePath variablePath, StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock targetParameter, NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDecapitalisedParameterDataBlock previous) {
						previous_ = previous;
						variablePathParameter_ = variablePath;
						targetParameterParameter_ = targetParameter;
						parent_ = parent;
					}
					public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.StringDecapitalisedParameterDataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
					}
					public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock getParent() {
						return parent_;
					}
					public final BaseTrackers.JavaVariablePath getVariablePathParameter() {
						return variablePathParameter_;
					}
					public final StringBuilderVariableAccessFormHolder.StringBuilderVariableAccessFormBlock getTargetParameterParameter() {
						return targetParameterParameter_;
					}
				}
				public static final class DoubleParameterDataBlock {
					private final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.DoubleParameterDataBlock previous_;
					public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock parent_;
					private final BaseTrackers.JavaVariablePath variablePathParameter_;
					private final DoubleBuilderVariableAccessFormHolder.DoubleBuilderVariableAccessFormBlock targetParameterParameter_;
					public DoubleParameterDataBlock(NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock parent, BaseTrackers.JavaVariablePath variablePath, DoubleBuilderVariableAccessFormHolder.DoubleBuilderVariableAccessFormBlock targetParameter, NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.DoubleParameterDataBlock previous) {
						previous_ = previous;
						variablePathParameter_ = variablePath;
						targetParameterParameter_ = targetParameter;
						parent_ = parent;
					}
					public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.DoubleParameterDataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
					}
					public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock getParent() {
						return parent_;
					}
					public final BaseTrackers.JavaVariablePath getVariablePathParameter() {
						return variablePathParameter_;
					}
					public final DoubleBuilderVariableAccessFormHolder.DoubleBuilderVariableAccessFormBlock getTargetParameterParameter() {
						return targetParameterParameter_;
					}
				}
				public static final class IntParameterDataBlock {
					private final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.IntParameterDataBlock previous_;
					public NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock parent_;
					private final BaseTrackers.JavaVariablePath variablePathParameter_;
					private final IntBuilderVariableAccessFormHolder.IntBuilderVariableAccessFormBlock targetParameterParameter_;
					public IntParameterDataBlock(NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock parent, BaseTrackers.JavaVariablePath variablePath, IntBuilderVariableAccessFormHolder.IntBuilderVariableAccessFormBlock targetParameter, NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.IntParameterDataBlock previous) {
						previous_ = previous;
						variablePathParameter_ = variablePath;
						targetParameterParameter_ = targetParameter;
						parent_ = parent;
					}
					public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock.IntParameterDataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
					}
					public final NameDetailsFormHolder.NameDetailsFormBlock.ComplexDataBlock.NameElementDataBlock getParent() {
						return parent_;
					}
					public final BaseTrackers.JavaVariablePath getVariablePathParameter() {
						return variablePathParameter_;
					}
					public final IntBuilderVariableAccessFormHolder.IntBuilderVariableAccessFormBlock getTargetParameterParameter() {
						return targetParameterParameter_;
					}
				}
			}
		}
	}
}
