package org.ffd2.skeletonx.skeleton;
public final class ParameterSettingsFormHolder {
	public static final class ParameterSettingsFormBlock {
		private final ParameterSettingsFormHolder.ParameterSettingsFormBlock previous_;
		public BaseBuilder parent_;
		public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parameterEnd_ = null;
		public ParameterSettingsFormBlock(BaseBuilder parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock previous) {
			previous_ = previous;
			parent_ = parent;
		}
		public final ParameterSettingsFormHolder.ParameterSettingsFormBlock getPrevious() {
			return previous_;
		}
		public final BaseBuilder getRootBuilder() {
			return parent_;
		}
		public final void setPostConstruction() {
		}
		public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
			if(previous_ != null) {
				previous_.resolutionPass(packageAccess);
			}
			if(parameterEnd_ != null) {
				parameterEnd_.resolutionPass(packageAccess);
			}
		}
		public final void finish() {
			if(previous_ != null) {
				previous_.finish();
			}
			if(parameterEnd_ != null) {
				parameterEnd_.finish();
			}
		}
		public final BaseBuilder getParent() {
			return parent_;
		}
		public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock getParameterEnd() {
			return parameterEnd_;
		}
		public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock addParameter(java.lang.String parameterName) {
			ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock child = new ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock(this, parameterName, parameterEnd_);
			parameterEnd_ = child;
			return child;
		}
		public static final class ParameterDataBlock {
			private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock previous_;
			public ParameterSettingsFormHolder.ParameterSettingsFormBlock parent_;
			public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock intEnd_ = null;
			public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock intArrayEnd_ = null;
			public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock stringEnd_ = null;
			public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock booleanEnd_ = null;
			public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock doubleEnd_ = null;
			public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock recordEnd_ = null;
			public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.ChainDataBlock chainEnd_ = null;
			public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock mappingEnd_ = null;
			public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock keyEnd_ = null;
			private final java.lang.String parameterNameParameter_;
			public ParameterDataBlock(ParameterSettingsFormHolder.ParameterSettingsFormBlock parent, java.lang.String parameterName, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock previous) {
				previous_ = previous;
				parameterNameParameter_ = parameterName;
				parent_ = parent;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
				if(intEnd_ != null) {
					intEnd_.resolutionPass(packageAccess);
				}
				if(intArrayEnd_ != null) {
					intArrayEnd_.resolutionPass(packageAccess);
				}
				if(stringEnd_ != null) {
					stringEnd_.resolutionPass(packageAccess);
				}
				if(booleanEnd_ != null) {
					booleanEnd_.resolutionPass(packageAccess);
				}
				if(doubleEnd_ != null) {
					doubleEnd_.resolutionPass(packageAccess);
				}
				if(recordEnd_ != null) {
					recordEnd_.resolutionPass(packageAccess);
				}
				if(chainEnd_ != null) {
					chainEnd_.resolutionPass(packageAccess);
				}
				if(mappingEnd_ != null) {
					mappingEnd_.resolutionPass(packageAccess);
				}
				if(keyEnd_ != null) {
					keyEnd_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
				if(intEnd_ != null) {
					intEnd_.finish();
				}
				if(intArrayEnd_ != null) {
					intArrayEnd_.finish();
				}
				if(stringEnd_ != null) {
					stringEnd_.finish();
				}
				if(booleanEnd_ != null) {
					booleanEnd_.finish();
				}
				if(doubleEnd_ != null) {
					doubleEnd_.finish();
				}
				if(recordEnd_ != null) {
					recordEnd_.finish();
				}
				if(chainEnd_ != null) {
					chainEnd_.finish();
				}
				if(mappingEnd_ != null) {
					mappingEnd_.finish();
				}
				if(keyEnd_ != null) {
					keyEnd_.finish();
				}
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock getParent() {
				return parent_;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock getIntEnd() {
				return intEnd_;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock addInt() {
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock child = new ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock(this, intEnd_);
				intEnd_ = child;
				return child;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock getIntArrayEnd() {
				return intArrayEnd_;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock addIntArray() {
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock child = new ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock(this, intArrayEnd_);
				intArrayEnd_ = child;
				return child;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock getStringEnd() {
				return stringEnd_;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock addString() {
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock child = new ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock(this, stringEnd_);
				stringEnd_ = child;
				return child;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock getBooleanEnd() {
				return booleanEnd_;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock addBoolean() {
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock child = new ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock(this, booleanEnd_);
				booleanEnd_ = child;
				return child;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock getDoubleEnd() {
				return doubleEnd_;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock addDouble() {
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock child = new ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock(this, doubleEnd_);
				doubleEnd_ = child;
				return child;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock getRecordEnd() {
				return recordEnd_;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock addRecord(DataBlockFormHolder.DataBlockFormBlock block) {
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock child = new ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock(this, block, recordEnd_);
				recordEnd_ = child;
				return child;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.ChainDataBlock getChainEnd() {
				return chainEnd_;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.ChainDataBlock addChain(ChainBlockFormHolder.ChainBlockFormBlock chain) {
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.ChainDataBlock child = new ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.ChainDataBlock(this, chain, chainEnd_);
				chainEnd_ = child;
				return child;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock getMappingEnd() {
				return mappingEnd_;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock addMapping(MappingBuilderFormHolder.MappingBuilderFormBlock mapping) {
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock child = new ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock(this, mapping, mappingEnd_);
				mappingEnd_ = child;
				return child;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock getKeyEnd() {
				return keyEnd_;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock addKey(KeyBuilderFormHolder.KeyBuilderFormBlock key) {
				ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock child = new ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock(this, key, keyEnd_);
				keyEnd_ = child;
				return child;
			}
			public final java.lang.String getParameterNameParameter() {
				return parameterNameParameter_;
			}
			public static final class IntDataBlock {
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock previous_;
				public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent_;
				private org.ffd2.bones.base.InstanceVariable parameterValue_Bones_;
				public IntDataBlock(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock previous) {
					previous_ = previous;
					parent_ = parent;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final org.ffd2.bones.base.InstanceVariable getParameterValue_BonesVariable() {
					return parameterValue_Bones_;
				}
				public final void setParameterValue_BonesVariable(org.ffd2.bones.base.InstanceVariable value) {
					parameterValue_Bones_ = value;
				}
			}
			public static final class IntArrayDataBlock {
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock previous_;
				public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent_;
				private org.ffd2.bones.base.InstanceVariable parameterValue_Bones_;
				public IntArrayDataBlock(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock previous) {
					previous_ = previous;
					parent_ = parent;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.IntArrayDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final org.ffd2.bones.base.InstanceVariable getParameterValue_BonesVariable() {
					return parameterValue_Bones_;
				}
				public final void setParameterValue_BonesVariable(org.ffd2.bones.base.InstanceVariable value) {
					parameterValue_Bones_ = value;
				}
			}
			public static final class StringDataBlock {
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock previous_;
				public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent_;
				private org.ffd2.bones.base.InstanceVariable parameterValue_Bones_;
				public StringDataBlock(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock previous) {
					previous_ = previous;
					parent_ = parent;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.StringDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final org.ffd2.bones.base.InstanceVariable getParameterValue_BonesVariable() {
					return parameterValue_Bones_;
				}
				public final void setParameterValue_BonesVariable(org.ffd2.bones.base.InstanceVariable value) {
					parameterValue_Bones_ = value;
				}
			}
			public static final class BooleanDataBlock {
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock previous_;
				public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent_;
				private org.ffd2.bones.base.InstanceVariable parameterValue_Bones_;
				public BooleanDataBlock(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock previous) {
					previous_ = previous;
					parent_ = parent;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.BooleanDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final org.ffd2.bones.base.InstanceVariable getParameterValue_BonesVariable() {
					return parameterValue_Bones_;
				}
				public final void setParameterValue_BonesVariable(org.ffd2.bones.base.InstanceVariable value) {
					parameterValue_Bones_ = value;
				}
			}
			public static final class DoubleDataBlock {
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock previous_;
				public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent_;
				private org.ffd2.bones.base.InstanceVariable parameterValue_Bones_;
				public DoubleDataBlock(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock previous) {
					previous_ = previous;
					parent_ = parent;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.DoubleDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final org.ffd2.bones.base.InstanceVariable getParameterValue_BonesVariable() {
					return parameterValue_Bones_;
				}
				public final void setParameterValue_BonesVariable(org.ffd2.bones.base.InstanceVariable value) {
					parameterValue_Bones_ = value;
				}
			}
			public static final class RecordDataBlock {
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock previous_;
				public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent_;
				public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsParameterDataBlock isParameterEnd_ = null;
				public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock isFixedEnd_ = null;
				private final DataBlockFormHolder.DataBlockFormBlock blockParameter_;
				private org.ffd2.bones.base.InstanceVariable parameterValue_Bones_;
				public RecordDataBlock(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent, DataBlockFormHolder.DataBlockFormBlock block, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock previous) {
					previous_ = previous;
					blockParameter_ = block;
					parent_ = parent;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
					if(isParameterEnd_ != null) {
						isParameterEnd_.resolutionPass(packageAccess);
					}
					if(isFixedEnd_ != null) {
						isFixedEnd_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
					if(isParameterEnd_ != null) {
						isParameterEnd_.finish();
					}
					if(isFixedEnd_ != null) {
						isFixedEnd_.finish();
					}
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsParameterDataBlock getIsParameterEnd() {
					return isParameterEnd_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsParameterDataBlock addIsParameter() {
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsParameterDataBlock child = new ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsParameterDataBlock(this, isParameterEnd_);
					isParameterEnd_ = child;
					return child;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock getIsFixedEnd() {
					return isFixedEnd_;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock addIsFixed(DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock thisBlockWithRoot, DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock arguments) {
					ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock child = new ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock(this, thisBlockWithRoot, arguments, isFixedEnd_);
					isFixedEnd_ = child;
					return child;
				}
				public final DataBlockFormHolder.DataBlockFormBlock getBlockParameter() {
					return blockParameter_;
				}
				public final org.ffd2.bones.base.InstanceVariable getParameterValue_BonesVariable() {
					return parameterValue_Bones_;
				}
				public final void setParameterValue_BonesVariable(org.ffd2.bones.base.InstanceVariable value) {
					parameterValue_Bones_ = value;
				}
				public static final class IsParameterDataBlock {
					private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsParameterDataBlock previous_;
					public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock parent_;
					public IsParameterDataBlock(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock parent, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsParameterDataBlock previous) {
						previous_ = previous;
						parent_ = parent;
					}
					public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsParameterDataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
					}
					public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock getParent() {
						return parent_;
					}
				}
				public static final class IsFixedDataBlock {
					private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock previous_;
					public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock parent_;
					private final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock thisBlockWithRootParameter_;
					private final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock argumentsParameter_;
					public IsFixedDataBlock(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock parent, DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock thisBlockWithRoot, DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock arguments, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock previous) {
						previous_ = previous;
						thisBlockWithRootParameter_ = thisBlockWithRoot;
						argumentsParameter_ = arguments;
						parent_ = parent;
					}
					public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock.IsFixedDataBlock getPrevious() {
						return previous_;
					}
					public final BaseBuilder getRootBuilder() {
						return parent_.getRootBuilder();
					}
					public final void setPostConstruction() {
					}
					public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
						if(previous_ != null) {
							previous_.resolutionPass(packageAccess);
						}
					}
					public final void finish() {
						if(previous_ != null) {
							previous_.finish();
						}
					}
					public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.RecordDataBlock getParent() {
						return parent_;
					}
					public final DataBlockFormHolder.DataBlockFormBlock.IsNotRootDataBlock getThisBlockWithRootParameter() {
						return thisBlockWithRootParameter_;
					}
					public final DesignArgumentValuesFormHolder.DesignArgumentValuesFormBlock getArgumentsParameter() {
						return argumentsParameter_;
					}
				}
			}
			public static final class ChainDataBlock {
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.ChainDataBlock previous_;
				public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent_;
				private final ChainBlockFormHolder.ChainBlockFormBlock chainParameter_;
				private org.ffd2.bones.base.InstanceVariable parameterValue_Bones_;
				public ChainDataBlock(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent, ChainBlockFormHolder.ChainBlockFormBlock chain, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.ChainDataBlock previous) {
					previous_ = previous;
					chainParameter_ = chain;
					parent_ = parent;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.ChainDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final ChainBlockFormHolder.ChainBlockFormBlock getChainParameter() {
					return chainParameter_;
				}
				public final org.ffd2.bones.base.InstanceVariable getParameterValue_BonesVariable() {
					return parameterValue_Bones_;
				}
				public final void setParameterValue_BonesVariable(org.ffd2.bones.base.InstanceVariable value) {
					parameterValue_Bones_ = value;
				}
			}
			public static final class MappingDataBlock {
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock previous_;
				public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent_;
				private final MappingBuilderFormHolder.MappingBuilderFormBlock mappingParameter_;
				private org.ffd2.bones.base.InstanceVariable parameterValue_Bones_;
				public MappingDataBlock(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent, MappingBuilderFormHolder.MappingBuilderFormBlock mapping, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock previous) {
					previous_ = previous;
					mappingParameter_ = mapping;
					parent_ = parent;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.MappingDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final MappingBuilderFormHolder.MappingBuilderFormBlock getMappingParameter() {
					return mappingParameter_;
				}
				public final org.ffd2.bones.base.InstanceVariable getParameterValue_BonesVariable() {
					return parameterValue_Bones_;
				}
				public final void setParameterValue_BonesVariable(org.ffd2.bones.base.InstanceVariable value) {
					parameterValue_Bones_ = value;
				}
			}
			public static final class KeyDataBlock {
				private final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock previous_;
				public ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent_;
				private final KeyBuilderFormHolder.KeyBuilderFormBlock keyParameter_;
				private org.ffd2.bones.base.InstanceVariable parameterValue_Bones_;
				public KeyDataBlock(ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock parent, KeyBuilderFormHolder.KeyBuilderFormBlock key, ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock previous) {
					previous_ = previous;
					keyParameter_ = key;
					parent_ = parent;
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock.KeyDataBlock getPrevious() {
					return previous_;
				}
				public final BaseBuilder getRootBuilder() {
					return parent_.getRootBuilder();
				}
				public final void setPostConstruction() {
				}
				public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
					if(previous_ != null) {
						previous_.resolutionPass(packageAccess);
					}
				}
				public final void finish() {
					if(previous_ != null) {
						previous_.finish();
					}
				}
				public final ParameterSettingsFormHolder.ParameterSettingsFormBlock.ParameterDataBlock getParent() {
					return parent_;
				}
				public final KeyBuilderFormHolder.KeyBuilderFormBlock getKeyParameter() {
					return keyParameter_;
				}
				public final org.ffd2.bones.base.InstanceVariable getParameterValue_BonesVariable() {
					return parameterValue_Bones_;
				}
				public final void setParameterValue_BonesVariable(org.ffd2.bones.base.InstanceVariable value) {
					parameterValue_Bones_ = value;
				}
			}
		}
	}
}
