package org.ffd2.skeletonx.skeleton;
public final class TemplateBlockFormHolder {
	public static final class TemplateBlockFormBlock {
		private final TemplateBlockFormHolder.TemplateBlockFormBlock previous_;
		public BaseBuilder parent_;
		public TemplateBlockFormHolder.TemplateBlockFormBlock.SubBlockDataBlock subBlockEnd_ = null;
		private final java.lang.String nameParameter_;
		private org.ffd2.bones.base.BClass templateInterfaceBonesClass_;
		public TemplateBlockFormBlock(BaseBuilder parent, java.lang.String name, TemplateBlockFormHolder.TemplateBlockFormBlock previous) {
			previous_ = previous;
			nameParameter_ = name;
			parent_ = parent;
		}
		public final TemplateBlockFormHolder.TemplateBlockFormBlock getPrevious() {
			return previous_;
		}
		public final BaseBuilder getRootBuilder() {
			return parent_;
		}
		public final void setPostConstruction() {
		}
		public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
			if(previous_ != null) {
				previous_.resolutionPass(packageAccess);
			}
			if(subBlockEnd_ != null) {
				subBlockEnd_.resolutionPass(packageAccess);
			}
		}
		public final void finish() {
			if(previous_ != null) {
				previous_.finish();
			}
			if(subBlockEnd_ != null) {
				subBlockEnd_.finish();
			}
		}
		public final BaseBuilder getParent() {
			return parent_;
		}
		public final TemplateBlockFormHolder.TemplateBlockFormBlock.SubBlockDataBlock getSubBlockEnd() {
			return subBlockEnd_;
		}
		public final TemplateBlockFormHolder.TemplateBlockFormBlock.SubBlockDataBlock addSubBlock(java.lang.String subBlockName, TemplateBlockFormHolder.TemplateBlockFormBlock child, ParameterSettingsFormHolder.ParameterSettingsFormBlock parameters) {
			TemplateBlockFormHolder.TemplateBlockFormBlock.SubBlockDataBlock child_1 = new TemplateBlockFormHolder.TemplateBlockFormBlock.SubBlockDataBlock(this, subBlockName, child, parameters, subBlockEnd_);
			subBlockEnd_ = child_1;
			return child_1;
		}
		public final java.lang.String getNameParameter() {
			return nameParameter_;
		}
		public final org.ffd2.bones.base.BClass getTemplateInterfaceBonesClass() {
			return templateInterfaceBonesClass_;
		}
		public final void setTemplateInterfaceBonesClass(org.ffd2.bones.base.BClass value) {
			templateInterfaceBonesClass_ = value;
		}
		public static final class SubBlockDataBlock {
			private final TemplateBlockFormHolder.TemplateBlockFormBlock.SubBlockDataBlock previous_;
			public TemplateBlockFormHolder.TemplateBlockFormBlock parent_;
			private final java.lang.String subBlockNameParameter_;
			private final TemplateBlockFormHolder.TemplateBlockFormBlock childParameter_;
			private final ParameterSettingsFormHolder.ParameterSettingsFormBlock parametersParameter_;
			public SubBlockDataBlock(TemplateBlockFormHolder.TemplateBlockFormBlock parent, java.lang.String subBlockName, TemplateBlockFormHolder.TemplateBlockFormBlock child, ParameterSettingsFormHolder.ParameterSettingsFormBlock parameters, TemplateBlockFormHolder.TemplateBlockFormBlock.SubBlockDataBlock previous) {
				previous_ = previous;
				subBlockNameParameter_ = subBlockName;
				childParameter_ = child;
				parametersParameter_ = parameters;
				parent_ = parent;
			}
			public final TemplateBlockFormHolder.TemplateBlockFormBlock.SubBlockDataBlock getPrevious() {
				return previous_;
			}
			public final BaseBuilder getRootBuilder() {
				return parent_.getRootBuilder();
			}
			public final void setPostConstruction() {
			}
			public final void resolutionPass(org.ffd2.bones.base.BPackage packageAccess) {
				if(previous_ != null) {
					previous_.resolutionPass(packageAccess);
				}
			}
			public final void finish() {
				if(previous_ != null) {
					previous_.finish();
				}
			}
			public final TemplateBlockFormHolder.TemplateBlockFormBlock getParent() {
				return parent_;
			}
			public final java.lang.String getSubBlockNameParameter() {
				return subBlockNameParameter_;
			}
			public final TemplateBlockFormHolder.TemplateBlockFormBlock getChildParameter() {
				return childParameter_;
			}
			public final ParameterSettingsFormHolder.ParameterSettingsFormBlock getParametersParameter() {
				return parametersParameter_;
			}
		}
	}
}
